; [about]
; <font face="Arial"><center>Ti-83 and Ti-83+ Assembly
; <B>Application Programming Interface</b>
; <i>Version of Tuesday 18-04-2006</i></center>
;
; Please see <a href="http://api.timendus.com/">http://api.timendus.com/</a> for a description on how to use this API in your program.
;
; <b>Variable types</b>
;
; &rarr; = 16-bits pointer to data
; # = 8-bits value (normal byte)
; % = 16-bits value (double byte)
;
; <b>Credits and License-shite</b>
;
; This API was "founded" by Tim Franssen a.k.a. Timendus, and has seen additions from various authors. Anyone can add to and improve this API on the web at <a href="http://api.timendus.com/">http://api.timendus.com/</a>. The copyright of the various routines in this API lies with their respective authors. Copyright for the idea and the website is held by Tim Franssen.
;
; You can use this API freely in any of your programs, under the condition that you give it credit, and add a link to <a href="http://api.timendus.com/">http://api.timendus.com/</a> in your readme and/or source. You are also under the obligation to give credit to authors who have explicitly stated so in the Interface documentation of their routines, and to uphold their requests and licenses.</font>
; [/about]


; <a name="Defines"></a>***
; <b><font size=4>Defines</font></b>
;



; ***
; [var]api_defines[/var]
; 
; Use
;  #define api_defines
;  #include api.inc
; To include the macro's at the beginning of your source
;



; ***
; [var]api_routines[/var]
; 
; Use
;  #define api_routines
;  #include api.inc
; To include the routines at the end of your program code
; (but before your data on Ti-83+ because of the boundary)
;

#IFDEF TI83
	#DEFINE API_TI83
#ENDIF

#IFDEF TI83I
	#DEFINE API_TI83
#ENDIF

#IFDEF TI83P
	#DEFINE API_TI83P
#ENDIF

#IFDEF TI83PI
	#DEFINE API_TI83P
#ENDIF

#IFDEF TI83PM
	#DEFINE API_TI83P
#ENDIF

; ***
; <b><font size=4>GUI</font></b>
;

; ***
; [routine]Readme[/routine]
;
; Warning: This section is still highly experimental!
;
; I'm still working on all of this, so don't be surprised if it all changes all of the sudden, or if things don't work as they should.
;
; Some feedback is always welcome though: api@timendus.com
;
; Written by:
;  Timendus
;

; ***
; [routine]gui.erase()[/routine]
;
; Erases plotsscreen.
;
; Example:
;  gui.erase()
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.erase() call api_gui_erase
   #DEFCONT  \ #DEFINE api_use_gui_erase

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_erase

api_gui_erase:

   ; Your code here

	ld hl,plotsscreen
	ld de,plotsscreen+1
	ld bc,767
	xor a
	ld (hl),a
	ldir
	ret

#ENDIF
#ENDIF

; ***
; [routine]gui.show()[/routine]
;
; Copies the contents of plotsscreen to the display.
; This routine is identical to ionFastCopy, so if you compile for Ion, you can use that routine to save space.
;
; Example:
;  gui.show()
;
; Written by:
;  Joe Wingbermuehle
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.show() call api_gui_show
   #DEFCONT  \ #DEFINE api_use_gui_show

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_show

api_gui_show:

   ; Your code here

	di
	ld	a,$80				; 7
	out	($10),a				; 11
	ld	hl,plotsscreen-12-(-(12*64)+1)		; 10
	ld	a,$20				; 7
	ld	c,a				; 4
	inc	hl				; 6 waste
	dec	hl				; 6 waste
api_gui_fastCopyAgain:
	ld	b,64				; 7
	inc	c				; 4
	ld	de,-(12*64)+1			; 10
	out	($10),a				; 11
	add	hl,de				; 11
	ld	de,10				; 10
api_gui_fastCopyLoop:
	add	hl,de				; 11
	inc	hl				; 6 waste
	inc	hl				; 6 waste
	inc	de				; 6
	ld	a,(hl)				; 7
	out	($11),a				; 11
	dec	de				; 6
	djnz	api_gui_fastCopyLoop		; 13/8
	ld	a,c				; 4
	cp	$2B+1				; 7
	jr	nz,api_gui_fastCopyAgain	; 10/1
	ret					; 10

#ENDIF
#ENDIF

; ***
; [routine]gui.textPlane(&#8594;string,%ul,%lr)[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.textPlane(string,ul,lr) load(bc,string)
   #DEFCONT  \ load(hl,ul)
   #DEFCONT  \ load(de,lr)
   #DEFCONT  \ ld a,1
   #DEFCONT  \ call api_gui_textPlane
   #DEFCONT  \ #DEFINE api_use_gui_textPlane

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_textPlane

   #DEFINE api_use_gui_printStr
   #DEFINE api_use_gui_drawPlane
   #DEFINE api_use_string_makeWrap

api_gui_textPlane:

   ; hl = string
   ; de = ul
   ; bc = lr

	push hl
	push de
	push bc
	or a
	jr z,api_gui_textField_Border
	call api_gui_drawPlane
	jr api_gui_textField_next
api_gui_textField_Border:
	call api_gui_drawField
api_gui_textField_next:
	pop hl		; str
	pop de		; coord2
	pop bc 	; coord1
	ld a,d
	sub b
	ld e,a
	push hl
	push bc
	call api_string_makeWrap
	pop bc
	pop hl
	ld e,b
	ld d,c
	inc d
	inc e \ inc e
	jp api_gui_printStr

#ENDIF
#ENDIF

; ***
; [routine]gui.textField(&#8594;string,%ul,%lr)[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.textField(string,ul,lr) load(bc,string)
   #DEFCONT  \ load(hl,ul)
   #DEFCONT  \ load(de,lr)
   #DEFCONT  \ call api_gui_textPlane
   #DEFCONT  \ xor a
   #DEFCONT  \ #DEFINE api_use_gui_textPlane

#ENDIF
#ENDIF

; ***
; [routine]gui.drawPlane(%ul,%lr)[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.drawPlane(ul,lr) load(hl,ul)
   #DEFCONT  \ load(de,lr)
   #DEFCONT  \ call api_gui_drawPlane
   #DEFCONT  \ #DEFINE api_use_gui_drawPlane

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_drawPlane

   #DEFINE api_use_gui_drawField

api_gui_drawPlane:

   ; hl = ul
   ; de = lr
   ; Your code here

	push hl
	push de
		inc h
		inc l
		inc d
		inc e
		inc d
		inc e
		ld a,$FF
		call api_draw_square
	pop de
	pop hl

	jp api_gui_drawField

#ENDIF
#ENDIF

; ***
; [routine]gui.drawField(%ul,%lr)[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.drawField(ul,lr) load(hl,ul)
   #DEFCONT  \ load(de,lr)
   #DEFCONT  \ call api_gui_drawField
   #DEFCONT  \ #DEFINE api_use_gui_drawField

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_drawField

   #DEFINE api_use_draw_square

api_gui_drawField:

   ; hl = ul
   ; de = lr
   ; Your code here

	inc d
	inc e
	ld a,$FF
	push hl
	push de
	call api_draw_square
	pop de
	pop hl
	inc h
	inc l
	dec d
	dec e
	xor a
	call api_draw_square
	ret

#ENDIF
#ENDIF

; ***
; [routine]gui.resetChoices()[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.resetChoices() call api_gui_resetChoices
   #DEFCONT  \ #DEFINE api_use_gui_resetChoices

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_resetChoices

   #DEFINE api_use_gui_goChoices

api_gui_resetChoices:

   ; Your code here

	ld hl,api_gui_choices
	ld (hl),0
	ld de,api_gui_choices+1
	ld bc,22
	ldir
	ret

#ENDIF
#ENDIF

; ***
; [routine]gui.setChoiceKeyHandler(&#8594;handler)[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.setChoiceKeyHandler(handler) load(hl,handler)
   #DEFCONT  \ call api_gui_setChoiceKeyHandler
   #DEFCONT  \ #DEFINE api_use_gui_setChoiceKeyHandler

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_setChoiceKeyHandler

api_gui_setChoiceKeyHandler:

   ; hl = handler
   ; Your code here

	ld (api_gui_keyhandler),hl
	ret

#ENDIF
#ENDIF

; ***
; [routine]gui.addChoice(&#8594;label,&#8594;routine)[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.addChoice(label,routine) load(hl,label)
   #DEFCONT  \ load(de,routine)
   #DEFCONT  \ call api_gui_addChoice
   #DEFCONT  \ #DEFINE api_use_gui_addChoice

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_addChoice

api_gui_addChoice:

   ; hl = label
   ; de = routine
   ; Your code here

	push hl
	ld d,0
	ld a,(api_gui_choices)
	ld e,a
	inc a
	ld (api_gui_choices),a
	ld hl,api_gui_choices+1
	add hl,de
	add hl,de
	add hl,de
	add hl,de
	ld (hl),b
	inc hl
	ld (hl),c
	pop bc
	inc hl
	ld (hl),b
	inc hl
	ld (hl),c
	ret

#ENDIF
#ENDIF

; ***
; [routine]gui.goChoices()[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.goChoices() jp api_gui_goChoices
   #DEFCONT  \ #DEFINE api_use_gui_goChoices

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_goChoices

   #DEFINE api_use_kbd_waitUp
   #DEFINE api_use_kbd_getKey

api_gui_goChoices:

	ld hl,plotsscreen+(12*56)
	ld (hl),$FF
	ld de,plotsscreen+(12*56)+1
	ld bc,11
	ldir
	inc hl
	inc de
	ld (hl),0
	ld bc,(12*7)-1
	ldir
	ld a,(api_gui_choices)
	ld b,a
	ld hl,api_gui_choices+1
	set textwrite,(iy+SGRFLAGS)
	ld e,-18
api_gui_goChoices_loop:
	push bc
	inc hl \ inc hl
	ld d,(hl)
	inc hl
	ld c,(hl)
	inc hl
	push hl
	ld h,d \ ld l,c
	ld a,19
	add a,e
	ld e,a
	ld d,57
	ld (pencol),de
	bcall(_vputs)
	pop hl
	pop bc
	djnz api_gui_goChoices_loop
	call ionFastCopy
	call api_kbd_waitUp
api_gui_goChoices_waitkey:
       call api_kbd_getKey
       or a
       jr z,api_gui_goChoices_waitkey
       
	cp $53
	jr z,api_gui_goChoices_firstpick
	cp $52
	jr z,api_gui_goChoices_secndpick
	cp $51
	jr z,api_gui_goChoices_thirdpick
	cp $50
	jr z,api_gui_goChoices_fourthpick
	cp $49
	jr z,api_gui_goChoices_fifthpick
	
	ld hl,(api_gui_keyhandler)
	ld d,a
	ld a,h
	or l
	jr z,api_gui_goChoices_waitkey
	
	ld a,d
	ld hl,api_gui_goChoices_waitkey
	push hl
	ld hl,(api_gui_keyhandler)
	push hl
	ret
	
api_gui_goChoices_firstpick:
	ld c,0
	jr api_gui_goChoices_pick
api_gui_goChoices_secndpick:
	ld c,1
	jr api_gui_goChoices_pick
api_gui_goChoices_thirdpick:
	ld c,2
	jr api_gui_goChoices_pick
api_gui_goChoices_fourthpick:
	ld c,3
	jr api_gui_goChoices_pick
api_gui_goChoices_fifthpick:
	ld c,4
api_gui_goChoices_pick:
	ld b,0
	ld hl,api_gui_choices+1
	add hl,bc
	add hl,bc
	add hl,bc
	add hl,bc
	ld d,(hl)
	inc hl
	ld e,(hl)
	ld a,d
	or e
	jr z,api_gui_goChoices_waitkey
	push de
	call api_kbd_waitUp
	ret
api_gui_choices:
	.db 0
	.fill 20,0
api_gui_keyhandler:
	.db 0,0

#ENDIF
#ENDIF

; ***
; [routine]gui.printStr(&#8594;str,%coords)[/routine]
;
; Insert routine description
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gui.printStr(str,coords) load(hl,str)
   #DEFCONT  \ load(de,coords)
   #DEFCONT  \ call api_gui_printStr
   #DEFCONT  \ #DEFINE api_use_gui_printStr

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gui_printStr

api_gui_printStr:

   ; hl = str
   ; de = coords
   ; hl = pointer to zero terminated string
   ;        \n indicates newline
   ; de = yx

	set   textwrite,(iy+SGRFLAGS)
	ld (pencol),de		; initial coordinates
api_gui_printStr_loop:
	ld a,(hl)
	or a				; return at end of string
	ret z
	cp '\n'				; newline at $FF
	jp z,api_gui_printStr_newline
	cp $FE
	jp z,api_gui_printStr_newline
	push de
	bcall(_vputmap)		; output character
	pop de
	inc hl
	jp api_gui_printStr_loop		; next char
api_gui_printStr_newline:
	ld a,e
	ld de,(pencol)
	ld e,a				; x = initial x
	ld a,d
	add a,6			; y = y+6
	ld d,a
	ld (pencol),de
	inc hl
	jp api_gui_printStr_loop		; next char

#ENDIF
#ENDIF

; ***
; <b><font size=4>Keyboard</font></b>
;

; ***
; [routine]kbd.readln.home(&#8594;buffer, #maxlength)[/routine]
;
; Get a zero terminated string from the user. String will be returned in <i>buffer</i>, and will have a length of <i>maxlength</i> or less. Input will be displayed to the user in the homescreen.
;
; Example:
;  kbd.readln.home(saferam1,255) ; 255 = highest maxlength
;  home.println(youtyped)
;  home.println(saferam1)
;  ...
;  youtyped: .db "You typed:",0
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   kbd.readln.home(buffer,maxlength) load(hl,buffer)
   #DEFCONT  \ load(b,maxlength)
   #DEFCONT  \ call    api_kbd_readln_home
   #DEFCONT  \ #DEFINE api_use_kbd_readln_home

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_kbd_readln_home

api_kbd_readln_home:

   ; hl = buffer
   ; b = maxlength
	push	bc
	push	hl
	bcall(_getkey)
	pop	hl
	pop	bc
	cp	5
	jr	z,api_kbd_readln_home_done
	cp	$99
	call	z,api_kbd_readln_home_space
	sub	89		 ; Capitals (with alpha)
	ld	(hl),a
	bcall(_putc)
	inc	hl
	djnz	api_kbd_readln_home
	dec	hl
api_kbd_readln_home_done:
	ld	(hl),0
	bcall(_newline)
	ret
api_kbd_readln_home_space:
	ld	a,' '+89
	ret

#ENDIF
#ENDIF

; ***
; [routine]kbd.readln.graph(&#8594;buffer, #maxlength)[/routine]
;
; Get a zero terminated string from the user. String will be returned in <i>buffer</i>, and will have a length of <i>maxlength</i> or less. Input will be displayed to the user in the graphscreen.
;
; Example:
;  kbd.readln.graph(saferam1,767) ; save 1 byte for the zero
;  graph.println(youtyped)
;  graph.println(saferam1)
;  ...
;  youtyped: .db "You typed:",0
;
; Depends on:
;  graph.newline
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   kbd.readln.graph(buffer,maxlength)   load(hl,buffer)
   #DEFCONT  \  load(b,maxlength)
   #DEFCONT  \ call    api_kbd_readln_graph
   #DEFCONT  \  #DEFINE api_use_kbd_readln_graph

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_kbd_readln_graph

#DEFINE api_use_graph_newline

api_kbd_readln_graph:

   ; hl = buffer
   ; b = maxlength
	set	textwrite,(iy+SGRFLAGS)
	push	bc
	push	hl
	call	ionFastCopy
	bcall(_getkey)
	pop	hl
	pop	bc
	cp	5
	jr	z,api_kbd_readln_graph_done
	cp	$99
	call	z,api_kbd_readln_graph_space
	sub	89		 ; Capitals (With alpha)
	ld	(hl),a
	ld	c,a
	push	bc
	bcall(_vputmap)
	pop	bc
	call	c,api_kbd_readln_graph_newline
	inc	hl
	djnz	api_kbd_readln_graph
api_kbd_readln_graph_done:
	ld	(hl),0
	jp	api_graph_newline
api_kbd_readln_graph_space:
	ld	a,' '+89
	ret
api_kbd_readln_graph_newline:
	push	hl
	call	api_graph_newline
	pop	hl
	ld	a,c
	bcall(_vputmap)
	ret

#ENDIF
#ENDIF

; ***
; [routine]kbd.waitkey()[/routine]
;
; Waits for a keypress and returns
;
; Example:
;  kbd.waitkey()
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   kbd.waitkey() call api_kbd_waitkey
   #DEFCONT  \ #DEFINE api_use_kbd_waitkey

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_kbd_waitkey

api_kbd_waitkey:

       call api_kbd_waitkey_check ; wait for key release
       jr nz,api_kbd_waitkey

api_kbd_waitkey_loop:

       call api_kbd_waitkey_check ; wait for keypress
       jr z,api_kbd_waitkey_loop

api_kbd_waitkey_loop2:

       call api_kbd_waitkey_check ; wait for key release
       jr nz,api_kbd_waitkey_loop2

	ret

api_kbd_waitkey_check:
       xor a
	out (1),a
	in a,(1)
       cp $FF
       ret

#ENDIF
#ENDIF

; ***
; [routine]kbd.waitUp()[/routine]
;
; Wait untill keys are released
;
; Example:
;  kbd.waitUp()
;  ; All keys are released
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   kbd.waitUp() call api_kbd_waitUp
   #DEFCONT  \ #DEFINE api_use_kbd_waitUp

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_kbd_waitUp

api_kbd_waitUp:

	xor a
	out (1),a
	in a,(1)
	cp $FF
	jr nz,api_kbd_waitUp
	ret

#ENDIF
#ENDIF

; ***
; [routine]kbd.scanKey()[/routine]
;
; Get a keyboard reading. Pretty stupid routine, but it was requested :)
;
; Example:
;  ld a,KEYGROUP
;  kbd.scanKey()
;  ; a = reading
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   kbd.scanKey() call api_kbd_scanKey
   #DEFCONT  \ #DEFINE api_use_kbd_scanKey

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_kbd_scanKey

api_kbd_scanKey:

	out (1),a
	in a,(1)
	ret

#ENDIF
#ENDIF

; ***
; [routine]kbd.getKey()[/routine]
;
; GetCSC like routine, returns key in a
;
; Example:
;<kbd>  loop:
;    kbd.getKey()
;    or a
;    jr z,loop
;    ; a = pressed key</kbd>
;
; Written by:
;  James Montelongo
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   kbd.getKey() call api_kbd_getKey
   #DEFCONT  \ #DEFINE api_use_kbd_getKey

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_kbd_getKey

api_kbd_getKey:

	ld a,$ff		;
	out (1),a		;reset keyport
	ld e,$fe		;frist group
	ld c,$01		;key port
	ld l,0		;l holds key pressed
api_kbd_getkey_cscloop:
	out (c),e		;set keygroup
	ld b,8		;loop, Delay needed when work with key driver
	in a,(c)		;read key
api_kbd_getkey_cscbit:
	inc l			;inc to get key pressed
	rra 			; if key pressed done
	jp nc,api_kbd_getkey_donecsc
	djnz api_kbd_getkey_cscbit 	;loop 8
	rlc e			;next key group
	jp m,api_kbd_getkey_cscloop	;if bit 7 set loop
	ld l,0		;if no key pressed 0
api_kbd_getkey_donecsc:
	ld a,l		;
	or a
	ld (api_kbd_getkey_keymem),a
	ret
api_kbd_getkey_keymem:
	.db 0

#ENDIF
#ENDIF

; ***
; <b><font size=4>Homescreen</font></b>
;

; ***
; [routine]home.output("string")[/routine]
;
; Print <i>string</i> to the Homescreen using "home.println". <i>string</i> can only be 14 characters due to TASM's limitations :'(. Hope to see that fixed when Brass comes out.
;
; If you need optimized code (either size or speed), use home.println instead.
;
; Example:
;  home.output("Hello world!")
;
; Size:
;  5 bytes routine + (4+string length) bytes invocation
;
; Depends on:
;  home.println
;
; Written by:
;  Timendus (idea by Jim e)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   home.output(string) call api_home_output
   #DEFCONT  \ .db string,0
   #DEFCONT  \ #DEFINE api_use_home_output

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_home_output

api_home_output:

   #DEFINE api_use_home_println

   pop	hl
   call	api_home_println
   jp	(hl)

#ENDIF
#ENDIF

; ***
; [routine]home.println(&#8594;str)[/routine]
;
; Print a zero terminated string to the homescreen, followed by a newline
;
; Example:
;  home.println(helloworld)
;  ...
;  helloworld: .db "Hello world",0
;
; Depends on:
;  home.print
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   home.println(str)   load(hl,str)
   #DEFCONT  \ call    api_home_println
   #DEFCONT  \ #DEFINE api_use_home_println

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_home_println

#DEFINE api_use_home_print
api_home_println:

   ; hl = str
	call	api_home_print
#IFDEF API_TI83
	jp	_newline
#ELSE
	bcall(_newline)
	ret
#ENDIF

#ENDIF
#ENDIF

; ***
; [routine]home.print(&#8594;str)[/routine]
;
; Print a zero terminated string to the homescreen, without a newline
;
; Example:
;  home.print(helloworld)
;  ...
;  helloworld: .db "Hello world",0
;
; Size:
;  83:  6 bytes
;  83+: 6 bytes routine + 6 bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

#IFDEF API_TI83
   #DEFINE   home.print(str)   load(hl,str)
   #DEFCONT  \ call _puts
#ELSE
   #DEFINE   home.print(str)   load(hl,str)
   #DEFCONT  \ call    api_home_print 
   #DEFCONT  \ #DEFINE api_use_home_print
#ENDIF

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_home_print

api_home_print:

   ; hl = str
	set	appAutoScroll,(iy+appFlags)
	bcall(_puts)
	ret

#ENDIF
#ENDIF

; ***
; [routine]home.clear()[/routine]
;
; Clears the homescreen and returns the cursor to the upperleftmost corner
;
; Example:
;  home.clear()
;
; Size:
;  83:  6 bytes routine
;  83+: 7 bytes routine
;         + 3 bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   home.clear()   call    api_home_clear
   #DEFCONT  \ #DEFINE api_use_home_clear

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_home_clear

api_home_clear:

   bcall(_clrLCDFull)
#IFDEF API_TI83
   jp _homeup
#ELSE
   bcall(_homeup)
   ret
#ENDIF

#ENDIF
#ENDIF

; ***
; [routine]home.newline()[/routine]
;
; Terminates the current line with a newline
;
; Example:
;  home.newline()
;
; Size:
;  3 bytes
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   home.newline()   bcall(_newline)

#ENDIF
#ENDIF

; ***
; [routine]home.putString(&#8594;str,%pos)[/routine]
;
; Use this routine if you want to display the string at <i>str</i> on the position <i>pos</i>. <i>pos</i> is a double byte with the first byte (MSB) being the y-coord and the second byte (LSB) being the x-coord.
;
; Untested, but should work :)
;
; Example:
;  home.putString(string,y*256+x)
;  ...
;  string: .db "Hello world!",0
;
; Size:
;  8 bytes routine + 9 bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   home.putString(str,pos) load(de,pos)
   #DEFCONT  \ load(hl,str)
   #DEFCONT  \ call api_home_putString
   #DEFCONT  \ #DEFINE api_use_home_putString

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_home_putString

api_home_putString:
   ld (curcol),de
   bcall(_puts)
   ret

#ENDIF
#ENDIF

; ***
; <b><font size=4>Graphscreen</font></b>
;

; ***
; [routine]graph.output("string")[/routine]
;
; Print <i>string</i> to the Graphscreen using "graph.println". If you use TASM, <i>string</i> can only be 14 characters long. With Brass, strings can be any length.
;
; If you need optimized code, you should use graph.println instead.
;
; Example:
;  graph.output("Hello world!")
;
; Size:
;  13 bytes routine + (4+string length) bytes invocation
;
; Depends on:
;  graph.println
;
; Written by:
;  Timendus (based on an idea by Jim e)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   graph.output(string) call api_graph_output
   #DEFCONT  \ .db string,0
   #DEFCONT  \ #DEFINE api_use_graph_output

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_graph_output

   #DEFINE api_use_graph_println

api_graph_output:

   pop	hl
   push	hl
   call	api_graph_println
   pop	hl
api_graph_output_loop:
   ld a,(hl)
   or a      ; Stop at end of string
   inc hl
   jr nz,api_graph_output_loop
   jp (hl)

#ENDIF
#ENDIF

; ***
; [routine]graph.println(&#8594;str)[/routine]
;
; Print a zero terminated string to the homescreen, followed by a newline
;
; Example:
;  graph.println(helloworld)
;  ...
;  helloworld: .db "Hello world",0
;
; Size:
;  6 bytes routine + 6 bytes invocation
;
; Depends on:
;  graph.print
;  graph.newline
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   graph.println(str)   load(hl,str)
   #DEFCONT  \ call    api_graph_println 
   #DEFCONT  \ #DEFINE api_use_graph_println

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_graph_println

#DEFINE api_use_graph_print
#DEFINE api_use_graph_newline

api_graph_println:

   ; hl = str
	call	api_graph_print
	jp	api_graph_newline

#ENDIF
#ENDIF

; ***
; [routine]graph.print(&#8594;str)[/routine]
;
; Print a zero terminated string to the graphscreen, using word wrap(!), without a newline
;
; ! Needs a bugfix for array.toString output that doesn't fit on the screen !
;
; Example:
;  graph.print(helloworld)
;  ...
;  helloworld: .db "Hello world",0
;
; Size:
;  76 bytes routine + 6 bytes invocation
;
; Depends on:
;  graph.newline
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   graph.print(str)   load(hl,str)
   #DEFCONT  \ call    api_graph_print
   #DEFCONT  \ #DEFINE api_use_graph_print

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_graph_print

#DEFINE api_use_graph_newline

api_graph_print:

   ; hl = str
	set	textwrite,(iy+SGRFLAGS)
api_graph_print_loop:
	ld	a,(hl)
	inc	hl
	or	a
	jp	z,ionFastCopy
	bcall(_vputmap)
	jr	nc,api_graph_print_loop

	ld	c,0
	push	hl
	dec	hl
api_graph_print_wrap:
	dec	hl

	push	hl		; calculate width to remove
	ld	l,(hl)
	ld	h,8
	bcall(_htimesl)
	bcall(_sfont_len)
	pop	hl
	ld	a,c
	add	a,b
	ld	c,a

	ld	a,(hl)		; go on untill space found
	cp	' '
	jr	nz,api_graph_print_wrap

	ld	a,c		; check if it's too wide to fit
	cp	60
	jr	c,api_graph_print_dowrap
	call	api_graph_newline
	pop	hl
	dec	hl
	jr	api_graph_print_loop

api_graph_print_dowrap:
	push	hl
	ld	hl,(PENCOL)
	ld	a,l
	sub	c
	ld	l,a
	ld	(PENCOL),hl
api_graph_print_wrap_loop:
	ld	a,' '
	bcall(_vputmap)
	jr	nc,api_graph_print_wrap_loop

	call	api_graph_newline
	pop	hl
	pop	de
	inc	hl
	jr	api_graph_print_loop

#ENDIF
#ENDIF

; ***
; [routine]graph.clear()[/routine]
;
; Clears the graphscreen and returns the cursor to the upperleftmost corner
;
; Example:
;  graph.clear()
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   graph.clear()   call    api_graph_clear
   #DEFCONT  \ #DEFINE api_use_graph_clear

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_graph_clear

api_graph_clear:

	res textInverse,(iy+textflags)
	bcall(_clrLCDFull)
	ld	hl,plotsscreen
	ld	de,plotsscreen+1
	ld	bc,767
	xor	a
	ld	(hl),a
	ldir
	ld	hl,$0101
	ld	(PENCOL),hl
	ret

#ENDIF
#ENDIF

; ***
; [routine]graph.newline()[/routine]
;
; Terminates the current line with a newline and will scroll the screen if neccessary
;
; Example:
;  graph.newline()
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   graph.newline()   call    api_graph_newline
   #DEFCONT  \ #DEFINE api_use_graph_newline

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_graph_newline

api_graph_newline:
	ld	hl,(PENCOL)
	ld	l,1
	ld	a,h
	add	a,6
	cp	60
	jr	nc,api_graph_newline_scrollup
	ld	h,a
	ld	(PENCOL),hl
	ret
api_graph_newline_scrollup:
	ld	(PENCOL),hl
	ld	de,plotsscreen
	ld	hl,plotsscreen+(6*12)
	ld	bc,768-(6*12)
	ldir
	ld	hl,plotsscreen+768-(6*12)
	ld	de,plotsscreen+768-(6*12)+1
	ld	bc,(6*12)-1
	xor	a
	ld	(hl),a
	ldir
	ret

#ENDIF
#ENDIF

; ***
; [routine]graph.putString(&#8594;str,%pos)[/routine]
;
; Use this routine if you do not want the "console like" functionality of graph.print, but you just want to display the string at <i>str</i> on the position <i>pos</i>. <i>pos</i> is a double byte with the first byte (MSB) being the y-coord and the second byte (LSB) being the x-coord.
;
; Example:
;  graph.putString(string,y*256+x)
;  ...
;  string: .db "Hello world!",0
;
; Size:
;  8 bytes routine + 9 bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   graph.putString(str,pos) load(de,pos)
   #DEFCONT  \ load(hl,str)
   #DEFCONT  \ call api_graph_putString
   #DEFCONT  \ #DEFINE api_use_graph_putString

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_graph_putString

api_graph_putString:
   set   textwrite,(iy+SGRFLAGS)
   ld (pencol),de
   bcall(_vputs)
   jp ionFastCopy

#ENDIF
#ENDIF

; ***
; <b><font size=4>Strings</font></b>
;

; ***
; [routine]string.compare(&#8594;str1,&#8594;str2)[/routine]
;
; Compares two zero terminated strings for equality, returns z flag:
;  z:  <i>str1</i> == <i>str2</i>
;  nz: <i>str1</i> != <i>str2</i>
;
; Example:
;  kbd.readln.home(buffer,8)
;  string.compare(buffer,compstr)
;  jr z,equalgo
;  home.println(notequal)
;  ret
;  ...
;  buffer: .fill 9,0
;  compstr: .db "FILENAME",0
;  notequal: .db "Not equal",0
;  equal: .db "Equal",0
;
; Written by:
;  Timendus
;  Rewritten by Ben Ryves
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.compare(str1,str2)   load(hl,str1)
   #DEFCONT  \ load(de,str2)
   #DEFCONT  \ call    api_string_compare
   #DEFCONT  \ #DEFINE api_use_string_compare

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_compare

api_string_compare:

   ; hl = str1
   ; de = str2
   ; Return z = equal, nz = not equal

   ld a,(de)
   or a
   jr z,api_string_compare_end
   xor (hl)
   ret nz   ; Nonidentical
   inc hl
   inc de
   jr api_string_compare
api_string_compare_end:
   or (hl)
   ret 

#ENDIF
#ENDIF

; ***
; [routine]string.insert(&#8594;str1,&#8594;str2,#pos)[/routine]
;
; Inserts a string at <i>str2</i> into a string at <i>str1</i> at <i>pos</i> characters from it's beginning. It's up to the user to make sure there's enough free space after str1 to accomodate str2.
;
; Example:
;  string.insert(hello,world,3)
;  home.println(hello)
;   ; Will output "Hello world"
;  world: .db "lo wo",0
;  hello: .db "Helrld",0
;  .fill 5,0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  string.size
;  string.copy
;  string.copyr
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.insert(str1,str2,pos) load(hl,str1)
   #DEFCONT  \ load(de,str2)
   #DEFCONT  \ load(c,pos)
   #DEFCONT  \ call api_string_insert
   #DEFCONT  \ #DEFINE api_use_string_insert

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_insert

api_string_insert:

   #DEFINE api_use_string_size
   #DEFINE api_use_string_copy
   #DEFINE api_use_string_copyr

   ; hl = str1
   ; de = str2
   ; c = pos

   ld b,0
   add hl,bc   ; hl = pointer to insert place
   push de
   push hl      ; stack top = [pointer to insert place, pointer to str2]
   ex de,hl     ; hl = pointer to str2
   call api_string_size
   pop hl       ; hl = pointer to insert place, bc = length of str2
   push hl
   add hl,bc   ; hl = where second half of str1 should go
   ex de,hl
   pop hl       ; hl = pointer to insert place
   push hl
   ld c,(hl)
   call api_string_copyr  ; copy second half str1 from insert place to new place
   pop de      ; de = pointer to insert place
   pop hl       ; hl = pointer to str2
   call api_string_copy
   ex de,hl
   dec hl
   ld (hl),c
   ret

#ENDIF
#ENDIF

; ***
; [routine]string.append(&#8594;str1,&#8594;str2)[/routine]
;
; Copies the string at <i>str2</i> after the string at <i>str1</i>. It's up to the user to make sure there's enough free memory after the string at <i>str1</i>!
;
; Example:
;  string.append(hello,world)
;  home.println(hello)
;   ; Will output "Hello world"
;  world: .db "world",0
;  hello: .db "Hello ",0
;  empty: .fill 5,0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.append(str1,str2) load(hl,str1)
   #DEFCONT  \ load(de,str2)
   #DEFCONT  \ call api_string_append
   #DEFCONT  \ #DEFINE api_use_string_append

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_append

api_string_append:

   ; hl = str1
   ; de = str2

api_string_append_loop1:

   ld a,(hl)
   or a      ; Find end of String
   inc hl
   jr nz,api_string_append_loop1

   dec hl
api_string_append_loop2:
   ld a,(de) ; Copy str2 after str1
   ld (hl),a
   inc hl
   inc de
   or a
   jr nz,api_string_append_loop2
   ret

#ENDIF
#ENDIF

; ***
; [routine]string.width(&#8594;str)[/routine]
;
; Calculates the width of a string in pixels when diplayed on the graphscreen and returns it in c.
;
; Example:
;  string.width(str)
;   ; c = 4+4+3+3+4 = 18
;  str: .db "Hello",0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.width(str) load(hl,str)
   #DEFCONT  \ call api_string_width
   #DEFCONT  \ #DEFINE api_use_string_width

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_width

api_string_width:

   ld c,0

api_string_width_loop:
   ld a,(hl)
   or a
   ret z
   push hl
   ld l,a
   ld h,8
   bcall(_htimesl)
   bcall(_sfont_len)
   pop hl
   inc hl
   ld a,c
   add a,b
   ld c,a
   jr api_string_width_loop

#ENDIF
#ENDIF

; ***
; [routine]string.copy(&#8594;from,&#8594;to)[/routine]
;
; Copies a string from location <i>from</i> to location <i>to</i>
;
; Example:
;  string.copy(str,saferam1)
;  home.println(saferam1)
;   ; will output "Hello"
;  str: .db "Hello",0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.copy(from,to) load(hl,from)
   #DEFCONT  \ load(de,to)
   #DEFCONT  \ call api_string_copy
   #DEFCONT  \ #DEFINE api_use_string_copy

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_copy

api_string_copy:

   ; hl = from
   ; de = to

   ld a,(hl)
   ld (de),a
   inc hl
   inc de
   or a
   jr nz,api_string_copy
   ret

#ENDIF
#ENDIF

; ***
; [routine]string.size(&#8594;str)[/routine]
;
; Returns the size of a string at <i>str</i> in bc. Doesn't count the terminating zero.
;
; Example:
;  string.size(str)
;   ; bc = 5
;  str: .db "Hello",0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.size(str) load(hl,str)
   #DEFCONT  \ call api_string_size
   #DEFCONT  \ #DEFINE api_use_string_size

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_size

api_string_size:

   ; hl = str

   ld bc,0
  
api_string_size_loop:

   ld a,(hl)
   or a      ; Stop at end of string
   ret z     ; bc = size
  
   inc hl
   inc bc
   jr api_string_size_loop

#ENDIF
#ENDIF

; ***
; [routine]string.copyr(&#8594;from,&#8594;to)[/routine]
;
; Copies a string from location <i>from</i> to location <i>to</i>, from back to front (useful in case you want to copy a string a few bytes further over itself)
;
; Example:
;  string.copy(str,saferam1)
;  string.copy(saferam1,saferam1+6)
;  home.println(saferam1)
;   ; will output "Sunny Sunny Day"
;  str: .db "Sunny Day",0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.copyr(from,to) load(hl,from)
   #DEFCONT  \ load(de,to)
   #DEFCONT  \ call api_string_copyr
   #DEFCONT  \ #DEFINE api_use_string_copyr

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_copyr

api_string_copyr:

   ; hl = from
   ; de = to

   ld b,1
api_string_copyr_loop1:
   inc hl
   inc de
   inc b
   ld a,(hl)
   or a
   jr nz,api_string_copyr_loop1

api_string_copyr_loop2:
   ld a,(hl)
   ld (de),a
   dec hl
   dec de
   djnz api_string_copyr_loop2

   ret

#ENDIF
#ENDIF

; ***
; [routine]string.reverse(&#8594;str)[/routine]
;
; Reverses a string at <i>str</i>. String should be less than 255 chars long, or this routine will do nothing and return.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  string.size
;
; Written by:
;  Ben Ryves
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.reverse(str) load(hl,str)
   #DEFCONT  \ call api_string_reverse
   #DEFCONT  \ #DEFINE api_use_string_reverse

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_reverse

   #DEFINE api_use_string_size

api_string_reverse:

   ; hl = str

   push hl
   call api_string_size
   dec hl
   ex de,hl
   pop hl    ; hl = pointer to start, de = pointer to end
   ld a,b
   or a
   ret nz     ; bail out if string longer than 255 chars
   or c
   ret z     ; bail out if string 0 chars long
   srl a
   or a
   ret z     ; bail out if string 1 char long

   ld b,a

   ; At this point, DE=pointer to last char, HL=pointer to start char, B=length>>1

api_string_reverse_loop:
   ld c,(hl)
   ld a,(de)
   ld (hl),a
   ld a,c
   ld (de),a

   inc hl
   dec de
   djnz api_string_reverse_loop

   ret

#ENDIF
#ENDIF

; ***
; [routine]string.toDouble(&#8594;str)[/routine]
;
; Converts a decimal string to a 16-bit value in hl
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  string.reverse
;
; Written by:
;  Ben Ryves
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.toDouble(str) load(hl,str)
   #DEFCONT  \ call api_string_toDouble
   #DEFCONT  \ #DEFINE api_use_string_toDouble

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_toDouble

   #DEFINE api_use_string_reverse

api_string_toDouble:

   ; hl = str

   push hl
   call api_string_reverse  ;Reverse so it's in units-tens-hundreds-thousands... order
   pop hl

   ld b,h
   ld c,l

   ld de,1
   ld hl,0

api_string_toDouble_get_next:
   ld a,(bc)
   or a
   ret z  ; Done
   sub '0'
   jr z,api_string_toDouble_got_digit

   push bc
   ld b,a
api_string_toDouble_get_unit:
   add hl,de
   djnz api_string_toDouble_get_unit
   pop bc

api_string_toDouble_got_digit:

   ; HL = running total. Save it away...
   push hl

   ; Now we need to DE*10:
   ex de,hl
   add hl,hl
   ld d,h
   ld e,l
   add hl,hl
   add hl,hl
   add hl,de
   ex de,hl
   pop hl
   inc bc
   jr api_string_toDouble_get_next

#ENDIF
#ENDIF

; ***
; [routine]string.countWords(&#8594;str)[/routine]
;
; Returns the number of words (or arguments in a command line situation) found in the string at <i>str</i> in registers a and c.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Ben Ryves
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.countWords(str) load(hl,str)
   #DEFCONT  \ call api_string_countWords
   #DEFCONT  \ #DEFINE api_use_string_countWords

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_countWords

api_string_countWords:

   ; hl = str

   ld c,1

   ld a,(hl)
   or a
   jr z,api_string_countWords_found
   cp ' '
   jr nz,api_string_countWords_nospace
   inc c
api_string_countWords_nospace:
   inc hl
   jr api_string_countWords

api_string_countWords_found:
   ld a,c
   ret

#ENDIF
#ENDIF

; ***
; [routine]string.getWord(&#8594;str,&#8594;word,#index,#maxwordsize)[/routine]
;
; Stores the <i>index</i>th word in the string at <i>str</i> in memory at <i>word</i>. Use <i>maxwordsize</i> to prevent overflow at <i>word</i>.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Ben Ryves
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.getWord(str,word,index) load(de,str)
   #DEFCONT  \ load(hl,word)
   #DEFCONT  \ load(a,index)
   #DEFCONT  \ load(b,maxwordsize)
   #DEFCONT  \ call api_string_getWord
   #DEFCONT  \ #DEFINE api_use_string_getWord

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_getWord

api_string_getWord:

   ; hl = word
   ; de = str
   ; a = index
   ; b = maxwordsize

   push bc
   or a
   jr z,api_string_getWord_found
   ld b,a
api_string_getWord_find:
   ld a,(de)
   cp ' '
   jr z,api_string_getWord_found_nearly
   or a
   jr z,api_string_getWord_found_null
   inc de
   jr api_string_getWord_find

api_string_getWord_found_nearly:
   inc de
   djnz api_string_getWord_find
api_string_getWord_found:
   pop bc

api_string_getWord_copy:
   ld a,(de)
   cp ' '
   jr nz,api_string_getWord_copy_notspace
   xor a
api_string_getWord_copy_notspace:
   ld (hl),a
   inc hl
   inc de
   or a
   ret z
   djnz api_string_getWord_copy
   ; Run off the end...
   dec hl
   ld (hl),0
   ret

api_string_getWord_found_null:   ; Past the end of the input string
   pop bc
   ld (hl),0
   ret

#ENDIF
#ENDIF

; ***
; [routine]string.makeWrap(&#8594;str,#width)[/routine]
;
; Add soft returns to a string. Designed to be used with gui.printStr()
;
; Example:
;  string.makeWrap(str,60)
;  ; string gets soft returns to make it fit within 60 pixels
;  str: .db "Hello world! This is a long string",0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   string.makeWrap(str,width) load(hl,str)
   #DEFCONT  \ load(e,width)
   #DEFCONT  \ call api_string_makeWrap
   #DEFCONT  \ #DEFINE api_use_string_makeWrap

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_string_makeWrap

api_string_makeWrap:

   ; hl = pointer to string
   ; e = max width

	push hl			; remove existing newlines
	push de
api_string_makeWrap_loop0:
	ld a,(hl)
	or a
	jr z,api_string_makeWrap_done
	cp $FE
	jp nz,api_string_makeWrap_skip
	ld a,' '
	ld (hl),a
api_string_makeWrap_skip:
	inc hl
	jp api_string_makeWrap_loop0
api_string_makeWrap_done:
	pop de
	pop hl

api_string_makeWrap_nextline:
	ld d,0				; current width = 0
api_string_makeWrap_loop1:
	ld a,(hl)
	inc hl
	or a				; return at end of string
	ret z
	cp '\n'				; new line at hard return
	jp z,api_string_makeWrap_nextline
	call api_string_makeWrap_charWidth
	ld a,d
	add a,b			; add width to total width of line
	ld d,a
	cp e				; max width exceeded?
	jp c,api_string_makeWrap_loop1
	
	ld d,0				; current width = 0 again
api_string_makeWrap_loop2:		; look for last space
	dec hl
	ld a,(hl)
	call api_string_makeWrap_charWidth
	ld a,d
	add a,b
	ld d,a
	cp e
	jr nc,api_string_makeWrap_next
	ld a,(hl)
	cp ' '
	jp nz,api_string_makeWrap_loop2
	
	ld a,$FE			; add newline there
	ld (hl),a
api_string_makeWrap_next:
	inc hl
	jp api_string_makeWrap_nextline		; next line
	
api_string_makeWrap_charWidth:
	push de
	push hl
	ld l,a
	ld h,8
	bcall(_htimesl)
	bcall(_sfont_len)		; b = width of char
	pop hl
	pop de
	ret

#ENDIF
#ENDIF

; ***
; <b><font size=4>User variables</font></b>
;

; ***
; [routine]var.read(#varchar)[/routine]
;
; Reads a value from a user variable (A-Z), result stored in a
;
; Example:
;  var.read('X')
;  ld h,0
;  ld l,a
;  bcall(_disphl)
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   var.read(varchar) load(a,varchar)
   #DEFCONT  \ call api_var_read
   #DEFCONT  \ #DEFINE api_use_var_read

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_var_read

api_var_read:

   ; a = varchar
	push	af
#IFDEF API_TI83
	bcall(_zerooop1)
#ELSE
	bcall(_zeroop1)
#ENDIF
	ld	hl,op1+1
	pop	af
	ld	(hl),a
	bcall(_rclvarsym)
	bcall(_convop1)
	ret

#ENDIF
#ENDIF

; ***
; [routine]var.write(%varchar,#value)[/routine]
;
; Writes a value to a user variable (A-Z)
;
; Example:
;  var.write('X',5) ; To load 5 in X
;  var.write('X',c) ; To load value of register c in X
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   var.write(varchar,value) load(hl,varchar)
   #DEFCONT  \ load(a,value)
   #DEFCONT  \ call api_var_write
   #DEFCONT  \ #DEFINE api_use_var_write

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_var_write

api_var_write:

   ; hl = varchar
   ; a = value
	push	hl
	bcall(_setxxop1)
	bcall(_PushRealO1)
#IFDEF API_TI83
	bcall(_zerooop1)
#ELSE
	bcall(_zeroop1)
#ENDIF
	pop	hl
	ld	(op1+1),hl
	bcall(_StoOther)
	ret

#ENDIF
#ENDIF

; ***
; <b><font size=4>Array</font></b>
;

; ***
; [routine]array.sort(&#8594;array,#terminator)[/routine]
;
; Sorts a given <i>array</i> or bytes, with <i>terminator</i> as the last byte. The array must have at least one element before the terminator.
;
; Example:
;  array.sort(arr,255)
;  ...
;  arr: .db 15,3,12,0,4,6,7,15,255
;
; Size:
;  15 bytes routine + 8 bytes invocation
;
; Written by:
;  CoBB
;    for the Sort that array! Maxcoderz programming competition
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   array.sort(array,terminator) load(de,array)
   #DEFCONT  \ load(c,terminator)
   #DEFCONT  \ call api_array_sort
   #DEFCONT  \ #DEFINE api_use_array_sort

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_array_sort

api_array_sort:

   ; de = array
   ; c = terminator

   ; Sort: sorts the C terminated array at DE
   ; Note: the array must have at least one element before the terminator.
   ; Routine size: 15 bytes

Sort:
   ld h,d             ; fetch array start address
   ld l,e
Sortloop:
   ld b,(hl)          ; advance until the first inversion
   inc hl
   ld a,(hl)
   cp c
   ret z              ; bail out at the terminator
   cp b
   jr nc,Sortloop
   ld (hl),b          ; swap the offending elements
   dec hl
   ld (hl),a
   jr Sort            ; start again from the beginning :o 

#ENDIF
#ENDIF

; ***
; [routine]array.shuffle(&#8594;ArrayPointer)[/routine]
;
; Shuffles an array of any length (max. 255) at <i>ArrayPointer</i>
; !!! Use 255 as end marker in the array !!! 
;
; Example:
;  array.shuffle(arr)
;  ...
;  arr: .db 1,2,3,4,4,6,7,15,255
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  ionRandom
;
; Written by:
;  Vincent Junemann (kv83)
;  Thanks goes to tr1p1ea and Jim E.

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   array.shuffle(ArrayPointer) load(hl,ArrayPointer)
   #DEFCONT  \ call api_array_shuffle
   #DEFCONT  \ #DEFINE api_use_array_shuffle

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_array_shuffle

api_array_shuffle:

   ; hl = ArrayPointer
lblShuffle: 
   ld d,h 
   ld e,l 
   ;--     Count the cards in the array     -- 
   ld b,$00    
lblShuffleCountCardsLoop: 
   ld a,(hl) 
   inc b 
   inc hl 
   cp 255 
   jr nz,lblShuffleCountCardsLoop 
   dec b 
   ld a,b 
   ld (CardsInArray),a 
   ld h,d 
   ld l,e 
   ;------------------------------------------ 
lblShuffleLoop:    
   ;--   Copy current card position to de   -- 
   push hl 
   push de 
   ld d,h 
   ld e,l 
   ;------------------------------------------ 
   ;--Search random position to shuffle with-- 
   ld a,(CardsInArray) 
   ld b,a 
   call ionrandom 
   ld b,$00 
   ld c,a 
   pop hl 
   push hl 
   add hl,bc 
   ;------------------------------------------    
   ;--   Shuffle values of both positions   -- 
   ld b,(hl) 
   ld a,(de) 
   ex de,hl 
   ld (de),a 
   ld (hl),b 
   ;------------------------------------------ 
   ;--         Go to next position          --    
   pop de 
   pop hl 
   inc hl 
   ld a,(hl) 
   cp 255 
   ret z 
   jr lblShuffleLoop 
   ;------------------------------------------
   ret

CardsInArray:
   .db 0

#ENDIF
#ENDIF

; ***
; [routine]array.toString(&#8594;arr,&#8594;strbuf,#term)[/routine]
;
; Formats a <i>term</i>-terminated array at <i>arr</i> to be displayed. Output string stored at <i>strbuf</i>. Output string will be (3 x (length of array) + 1) bytes long and displayed in hexadecimal form.
;
; Example:
;  array.toString(array,saferam1,255)
;  home/graph.println(saferam1)
;  ...
;  array: .db 1,2,3,4,255
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   array.toString(arr,strbuf,term) load(de,arr)
   #DEFCONT  \ load(hl,strbuf)
   #DEFCONT  \ load(c,term)
   #DEFCONT  \ call api_array_format
   #DEFCONT  \ #DEFINE api_use_array_format

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_array_format

api_array_format:

   ; de = arr
   ; hl = strbuf
   ; c = term

   ld (hl),$C1
   inc hl

api_array_format_loop:
   ld a,(de)
   cp c
   jr z,api_array_format_done
   ld b,a
   srl a
   srl a
   srl a
   srl a
   call api_array_format_tochar
   ld (hl),a
   inc hl
   ld a,b
   and %00001111
   call api_array_format_tochar
   ld (hl),a
   inc hl
   ld (hl),$2C
   inc hl
   inc de
   jr api_array_format_loop

api_array_format_tochar:
   add a,$30
   cp $3a
   ret c
   add a,7
   ret

api_array_format_done:
   dec hl
   ld (hl),$5D
   inc hl
   ld (hl),0
   ret

#ENDIF
#ENDIF

; ***
; [routine]array.getval(&#8594;arr,#index,#term)[/routine]
;
; Get value at <i>index</i> in <i>term</i>-terminated array at <i>arr</i>. Index starting from 0. If <i>index</i> is outside array, <i>term</i> will be returned.
;
; Example:
;  array.getval(array,2,$FF)
;   ; a = $7B
;  array: .db $E3,$73,$7B,$83,$FF
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   array.getval(arr,index,term) load(hl,arr)
   #DEFCONT  \ load(b,index)
   #DEFCONT  \ load(c,term)
   #DEFCONT  \ call api_array_getval
   #DEFCONT  \ #DEFINE api_use_array_getval

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_array_getval

api_array_getval:

   ; hl = arr
   ; b = index
   ; c = term

   ld a,b    ; Check for index = 0
   or a
   jr z,api_array_getval_skip
   
   ld a,(hl)
   cp c      ; Stop at end of array
   ret z     ; a = term
   
   inc hl
   djnz api_array_getval

api_array_getval_skip:
   ld a,(hl)
   ret

#ENDIF
#ENDIF

; ***
; [routine]array.indexOf(&#8594;arr,#value,#term)[/routine]
;
; Find the index of <i>value</i> in the <i>term</i>-terminated array at <i>arr</i>. Returns found index in a or <i>term</i> if not found. Index starts at 0. It has linear time complexity, but I don't think you can do any better with an unsorted list on a calculator :)
;
; Example:
;  array.indexOf(array,5,$FF)
;   ; returns 2 in a and e
;  array: .db 9,2,5,4,255
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   array.indexOf(arr,value,term) load(hl,arr)
   #DEFCONT  \ load(b,value)
   #DEFCONT  \ load(c,term)
   #DEFCONT  \ call api_array_indexOf
   #DEFCONT  \ #DEFINE api_use_array_indexOf

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_array_indexOf

api_array_indexOf:

   ; hl = arr
   ; b = value
   ; c = term

   ld e,0
   
api_array_indexof_loop:

   ld a,(hl)
   cp c      ; Stop at end of array
   ret z     ; a = term
   cp b
   ld a,e
   ret z
   
   inc hl
   inc e
   jr api_array_indexof_loop

#ENDIF
#ENDIF

; ***
; [routine]array.size(&#8594;arr,#term)[/routine]
;
; Returns number of elements in <i>term</i>-terminated array at <i>arr</i> in a and e.
;
; Example:
;  array.size(array,$FF)
;   ; a = e = 5
;  array: .db 1,2,3,4,5,255
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   array.size(arr,term) load(hl,arr)
   #DEFCONT  \ load(b,term)
   #DEFCONT  \ call api_array_size
   #DEFCONT  \ #DEFINE api_use_array_size

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_array_size

api_array_size:

   ; hl = arr
   ; b = term

   ld e,0
  
api_array_size_loop:

   ld a,(hl)
   cp b      ; Found end
   ld a,e
   ret z     ; so return

   inc hl
   inc e
   jr api_array_size_loop

#ENDIF
#ENDIF

; ***
; [routine]array.store(&#8594;arr,#val,#index)[/routine]
;
; Stores a value <i>val</i> in an array at <i>arr</i> at element <i>index</i>. It's up to the user to make sure <i>index</i> lies between 0 and array.size()-1.
;
; ! Hasn't been tested yet !
;
; Example:
;  array.store(arr,5,2)
;   ; 3 in arr will become 5
;  arr: .db 1,2,3,4,255
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   array.store(arr,val,index) load(hl,arr)
   #DEFCONT  \ load(a,val)
   #DEFCONT  \ load(b,index)
   #DEFCONT  \ call api_array_store
   #DEFCONT  \ #DEFINE api_use_array_store

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_array_store

api_array_store:

   ; hl = arr
   ; a = val
   ; b = index

   inc b
   dec hl
loop:
   inc hl
   djnz loop
   ld (hl),a
   ret

#ENDIF
#ENDIF

; ***
; <b><font size=4>Link port</font></b>
;

; ***
; [routine]link.read()[/routine]
;
; Reads a byte from the link port
; The byte is stored in the accumulator
;
; <b>Needs some fixing!</b>
;
; Example:
;  
;  link.read()
;  ld h,0
;  ld l,a
;  bcall(_disphl)
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Skneel
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   link.read() call api_link_read
   #DEFCONT  \ #DEFINE api_use_link_read

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_link_read

api_link_read:
   ld a,22
   ld (ASM_IND_CALL),a
   jp IO_EXEC

#ENDIF
#ENDIF

; ***
; [routine]link.read1st()[/routine]
;
; Waits until a byte is recieved from the link port
;
; <b>Needs some fixing!</b>
;
; Example:
;  link.read1st()
;  ld h,0
;  ld l,a
;  bcall(_disphl)
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Skneel
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   link.read1st() call api_link_read1st
   #DEFCONT  \ #DEFINE api_use_link_read1st

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_link_read1st

api_link_read1st:
   ld a,19
   ld (ASM_IND_CALL),a
   jp IO_EXEC

#ENDIF
#ENDIF

; ***
; [routine]link.write(#byte)[/routine]
;
; Writes a byte to the link port
;
; Example:
;  link.write(5)
;  or
;  link.write(c) ; To send value of c
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Skneel
;  Edited by Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

#IFDEF API_TI83

   #DEFINE link.write(val) load(a,val)
   #DEFCONT \ call api_link_sendbyte
   #DEFCONT \ #DEFINE api_use_link_write

#ELSE

   #DEFINE link.write(val) ld a,val
   #DEFCONT \ bcall(_sendabyte)

#ENDIF

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_link_write

api_link_write:
	push af
	ld a,11
	ld (ASM_IND_CALL),a
	pop af
	jp _IO_EXEC

#ENDIF
#ENDIF

; ***
; [routine]link.remoteKey()[/routine]
;
; Simulates a key press on a calculator connected through the link port
; Doesn't work for Ti-83 unfortunately... who can fix the bug? :S
;
; Example:
;  link.remoteKey($9B)
;  or
;  bcall(_getkey)
;  link.remoteKey(a)
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  link.write
;
; Written by:
;  Skneel
;  Edited by Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   link.remoteKey(val) load(a,val)
   #DEFCONT  \ call api_link_remoteKey
   #DEFCONT  \ #DEFINE api_use_link_remoteKey

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_link_remoteKey

api_link_remoteKey:
   push af
#IFDEF API_TI83
   link.write(3)   ; I'm a PC
#ELSE
   link.write($83) ; I'm a PC
#ENDIF
   link.write($87) ; Receive a key
   pop af
   link.write(a)    ; This key (in a)
   xor a
   link.write(a)    ; Done
   ret

#ENDIF
#ENDIF

; ***
; <b><font size=4>Memory</font></b>
;

; ***
; [routine]mem.init()[/routine]
;
; ! Untested and not unlikely to be 83+ only !
;
; This routine initializes the memory manager system. It must be called before using any of the other memory management routines, else the system will die a horrible death. It takes the area of memory designated as "User RAM" for use as the dynamic memory pool and initializes it as one free block. You are thus not allowed to use any calculator functionality that would cause this area to shrink (e.g. using FP and variable routines), otherwise the memory pool will become corrupted.
;
; Example:
;  mem.init()
;  - other memory routines -
;
; Written by:
;  Sean McLaughlin
;
; License:
;
; Copyright (c) 2005, Sean McLaughlin. All rights reserved.
; Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
;
; Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
;
; Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
;
; Neither the name of United-TI, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. 
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
; OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   mem.init() call api_mem_init
   #DEFCONT  \ #DEFINE api_use_mem_init

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_mem_init

api_mem_init:

mem_init:
p_PoolStart	.equ	$9824	; FPS
p_PoolEnd	.equ	$9828	; OPS
BDR_HEADER_SIZE	.equ	7
GRANULARITY	.equ	16
MIN_POOL_SIZE	.equ	128

p_LastBlock	.dw	0

	; Get the amount of free memory (MemChk)
	ld	hl, (p_PoolEnd)
	ld	de, (p_PoolStart)
	or	a
	sbc	hl, de

	; Do we have enough to work with?
	ld	a, h
	or	a
	jr	nz, _good
	ld	a, l
	cp	MIN_POOL_SIZE
	ret	c

	; Init as one big BDR
_good:
	; Get the block size minus overhead
	ld	bc, -BDR_HEADER_SIZE
	add	hl, bc

	ex	de, hl
	xor	a
	; Set memory pointer
	ld	(p_LastBlock), hl
	; Set status byte to free
	ld	(hl), a
	; Set forward link to NULL
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), a
	; Set back link to NULL
	inc	hl
	ld	(hl), a
	inc	hl
	ld	(hl), a
	; Set size word
	inc	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
	ret

#ENDIF
#ENDIF

; ***
; [routine]mem.alloc(%bytes)[/routine]
;
; ! Untested and not unlikely to be 83+ only !
;
; mem.alloc is the routine you use to allocate a block of memory. If it can locate a block that is large enough to satisfy the requested number of bytes, it will allocate it and return a pointer to the block in hl. If the allocation failed the carry flag will be set.
;
; Example:
;  mem.init()
;  mem.alloc(2000)   ; Allocate 2000 bytes
;  jr c,mem_error
;  ; hl = pointer to 2000 bytes of free memory space
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Sean McLaughlin
;
; License:
;
; Copyright (c) 2005, Sean McLaughlin. All rights reserved.
; Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
;
; Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
;
; Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
;
; Neither the name of United-TI, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. 
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
; OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   mem.alloc(bytes) load(bc,bytes)
   #DEFCONT  \ call api_mem_alloc
   #DEFCONT  \ #DEFINE api_use_mem_alloc

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_mem_alloc

api_mem_alloc:

   ; hl = bytes
mem_alloc:
	; IN   BC = Requested amount
	; OUT  HL = Address of allocated memory
	;      CY = 1 if failure

	; Look for a free block
	ld	hl, (p_LastBlock)
	ld	d, h
	ld	e, l
_Search:
	ld	a, (hl)		; If the status field is zero, maybe...
	or	a
	jr	z, _Maybe
_Search2:
	inc	hl		; Go to the next link
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	or	h
	jr	nz, _ValidAddress
	; Oops, null pointer. Have to restart from beginning
	ld	hl, (p_PoolStart)
_ValidAddress:
	; Did we run through the list?
	push	hl
	sbc	hl, de
	pop	hl
	jr	nz, _Search
	scf
	ret
		
_Maybe:
	; Is the block big enough?
	push	hl
		ld	de, 5
		add	hl, de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		sbc	hl, bc		; HL = difference of sizes
		jr	nc, _ItsGood
	; Failed, go back to the search loop
	pop	hl
	ld	de, (p_LastBlock)
	jr	_Search2

_ItsGood:
	; Split or grab?  HL = remainder
		ld	de, GRANULARITY
		push	hl
			sbc	hl, de
		pop	hl
		jr	nc, _Split
	; Nab the whole effin' thing and book
	pop	hl
	ld	(hl), 1			; The links and size fields are set up just fine
	ret

_Split:
		ex	(sp), hl
		ld	(hl), 1
		push	hl
	; Set the size of this block
			inc	hl
			ld	d, h
			ld	e, l
			inc	hl
			inc	hl
			inc	hl
			inc	hl
			ld	(hl), c
			inc	hl
			ld	(hl), b
			add	hl, bc
			inc	hl
	; Split it apart
			ld	(hl), 0
			ld	(p_LastBlock), hl
	; HL = &newb
	; DE = &this.next_lsb
	; (SP) = difference | &this
	; Set new.next = this.next
			ld	b, h
			ld	c, l		; BC = &newb
			inc	bc
			inc	bc
			ex	de, hl		; HL = this.next_lsb
			inc	de		; DE = newb.next_lsb
			ldi
			ldi
			
	; HL = &this.prev_lsb
	; BC = &newb
	; DE = &newb.prev_lsb
	; (SP) = difference | &this
	; Set newb.prev = &this
		pop	hl		; HL = &this
		ex	de, hl		; HL = &newb.prev_lsb   DE = &this
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
	; HL = &newb.size_lsb
	; BC = &newb
	; DE = &this
	; (SP) = difference
	; Set this.next = &new
		inc	de		; DE = &this.next_lsb
		ld	a, c
		ld	(de), a
		inc	de		; DE = &this.next_msb
		ld	a, b
		ld	(de), a

	; HL = &newb.size_lsb		
	; DE = &this.next_msb
	; Set new.size = difference
	pop	bc
	ld	(hl), c
	inc	hl
	ld	(hl), b
	
	; Return pointer
	ld	hl, BDR_HEADER_SIZE-2
	add	hl, de
	ret

#ENDIF
#ENDIF

; ***
; [routine]mem.free(%block)[/routine]
;
; ! Untested and not unlikely to be 83+ only !
;
; Use this routine to deallocate a block of memory that was previously allocated by 'mem_alloc'. If you attempt to free a pointer that is invalid, or has already been freed, the result is undefined (usually, the memory pool is corrupt).
;
; Example:
;  mem.init()
;  mem.alloc(2000)   ; Allocate 2000 bytes
;  jr c,mem_error
;  ; hl = pointer to 2000 bytes of free memory space
;  mem.free(hl)
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Sean McLaughlin
;
; License:
;
; Copyright (c) 2005, Sean McLaughlin. All rights reserved.
; Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
;
; Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
;
; Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
;
; Neither the name of United-TI, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. 
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
; OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   mem.free(block) load(hl,block)
   #DEFCONT  \ call api_mem_free
   #DEFCONT  \ #DEFINE api_use_mem_free

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_mem_free

api_mem_free:

   ; hl = block
	; IN   HL = address

	; Get block size
	dec	hl			; HL = &this.size_msb
	push	hl
	ld	b, (hl)
	dec	hl			; HL = &this.size_lsb
	ld	c, (hl)			; BC = size
	; Conglomerate with previous block
	dec	hl			; HL = &this.prev_msb
	ld	d, (hl)
	dec	hl			; HL = &this.prev_lsb
	ld	e, (hl)			; DE = &prev

	ld	a, d
	or	e
	jr	z, _PrevIsUsed		; Null pointer :'(

	ld	a, (de)
	or	a
	jr	nz, _PrevIsUsed
	ld	(p_LastBlock), de	; Block is free!
	pop	af
	inc	de
	inc	de			; DE = &prev.next_msb
	call	_SetLink
	ld	a, (hl)
	inc	hl			; HL = &prev.size_msb
	push	hl
	ld	h, (hl)
	ld	l, a
	add	hl, bc
	ex	de, hl			; HL = &this.size_lsb
	ld	b, d
	ld	c, e			; DE = BC = size

	dec	hl
	dec	hl
	jr	$+6
_PrevIsUsed:
	ld	(p_LastBlock), de
	; Conglomerate with next block
	dec	hl
	ld	d, (hl)
	dec	hl
	ld	e, (hl)
	
	ld	a, d
	or	e
	jr	z, _NextIsUsed		; NULL pointer!

	ld	a, (de)
	or	a
	jr	nz, _NextIsUsed
	call	_SetLink
	inc	hl
	inc	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl, bc
	ex	de, hl
	ld	b, d
	ld	c, e
_NextIsUsed:
	pop	hl
	ld	(hl), b
	dec	hl
	ld	(hl), c
	ld	bc, -5
	add	hl, bc
	ld	(hl), 0
	ret

	; Using these procs save a grand total of 4 bytes!!!
_SetLink:
	inc	de
	ex	de, hl
	ldi
	inc	bc
	ldi
	inc	bc
	ret

#ENDIF
#ENDIF

; ***
; [routine]mem.available()[/routine]
;
; ! Untested and not unlikely to be 83+ only !
;
; Use this routine to determine size of the largest block of free memory currently available. Each block has an overhead of 7 bytes, so the output of this routine minus 7 will be the largest value that can be passed to 'mem.alloc' successfully. Result will be returned in bc.
;
; Example:
;  mem.init()
;  mem.available()
;  mem.alloc(bc)
;  ...
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Sean McLaughlin
;
; License:
;
; Copyright (c) 2005, Sean McLaughlin. All rights reserved.
; Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
;
; Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
;
; Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
;
; Neither the name of United-TI, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
; OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   mem.available() call api_mem_available
   #DEFCONT  \ #DEFINE api_use_mem_available

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_mem_available

api_mem_available:

mem_avail:
	; OUT   BC = Size of largest free block
	ld	hl, (p_LastBlock)
	ld	d, h
	ld	e, l
	ld	bc, 0
_Find:
	ld	a, (hl)
	or	a
	jr	z, _Test
_Return:
	inc	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	or	h
	jr	nz, _ValidAddress
	ld	hl, (p_PoolStart)
_ValidAddress:
	push	hl
	xor	a
	sbc	hl, de
	pop	hl
	jr	nz, _Find
	ret
_Test:
	push	de
	push	hl
	ld	de, 5
	add	hl, de
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	sbc	hl, bc
	jr	c, _TooBad
	ld	b, h
	ld	c, l
_TooBad:
	pop	hl
	pop	de
	jr	_Return

#ENDIF
#ENDIF

; ***
; <b><font size=4>Sprites</font></b>
;

; ***
; [routine]sprite.flip(&#8594;sprite,#height)[/routine]
;
; Horizontally flips a 1 byte wide sprite.
;
; Example:
;  sprite.flip(left,8)
;   ; Sprite "left" looks right :)
;  left: .db -sprite data-
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus and DarkerLine
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   sprite.flip(sprite,height) load(hl,sprite)
   #DEFCONT  \ load(b,height)
   #DEFCONT  \ call api_sprite_flip
   #DEFCONT  \ #DEFINE api_use_sprite_flip

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_sprite_flip

api_sprite_flip:

   ; hl = sprite
   ; a = height

   ld c,(hl)
   push bc
   ld b, 8
api_sprite_flip_loop:
   rlc c
   rra
   djnz api_sprite_flip_loop
   pop bc
   ld (hl),a
   inc hl
   djnz api_sprite_flip
   ret

#ENDIF
#ENDIF

; ***
; [routine]sprite.invert(&#8594;sprite,#height)[/routine]
;
; Invert a 1 byte wide sprite
;
; Example:
;  sprite.invert(whitechesspiece,8)
;   ; sprite "whitechesspiece" can be used for black :)
;  whitechesspiece: .db -spritedata-
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   sprite.invert(sprite,height) load(hl,sprite)
   #DEFCONT  \ load(b,height)
   #DEFCONT  \ call api_sprite_invert
   #DEFCONT  \ #DEFINE api_use_sprite_invert

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_sprite_invert

api_sprite_invert:

   ; hl = sprite
   ; b = height

   ld a,(hl)
   cpl
   ld (hl),a
   inc hl
   djnz api_sprite_invert
   ret

#ENDIF
#ENDIF

; ***
; [routine]sprite.flipWide(&#8594;sprite,#height)[/routine]
;
; Horizontally flips a 2 bytes wide sprite with height <i>height</i> (Poetic, isn't it? :P)
;
; Example:
;  See sprite.flip :)
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Modification of sprite.flip by DarkerLine
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   sprite.flipWide(sprite,height) load(hl,sprite)
   #DEFCONT  \ load(b,height)
   #DEFCONT  \ call api_sprite_flipWide
   #DEFCONT  \ #DEFINE api_use_sprite_flipWide

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_sprite_flipWide

api_sprite_flipWide:

   ; hl = sprite
   ; b = height

   ld c, (hl)
   inc hl
   ld d, (hl)
   push bc
   ld b, 8
api_sprite_flipWide_loop:
   rlc c
   rra
   rlc d
   rr e
   djnz api_sprite_flipWide_loop
   ld (hl), a
   dec hl
   ld (hl), e
   inc hl
   inc hl
   pop bc
   djnz api_sprite_flipWide
   ret

#ENDIF
#ENDIF

; ***
; [routine]sprite.drawAnd(&#8594;sprite,%pos)[/routine]
;
; ANDs a sprite at <i>sprite</i> with plotsscreen at position <i>pos</i>. <i>pos</i> is a double byte with the first byte (MSB) being the x-coord and the second byte (LSB) being the y-coord. Sprite data should be in this format:
;
; <kbd>sprite:
;  .db number_of_rows
;  .db row_1
;  .db row_2
;  ...
;  .db row_N</kbd>
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Sean McLaughlin
;    (Taken from the "Best Damn Sprite Routines Period" package)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   sprite.drawAnd(sprite,pos) load(hl,sprite)
   #DEFCONT  \ load(de,pos)
   #DEFCONT  \ call api_sprite_drawAnd
   #DEFCONT  \ #DEFINE api_use_sprite_drawAnd

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_sprite_drawAnd

api_sprite_drawAnd:

   ; hl = sprite
   ; de = pos

   #define	A_PIXEL_SHIFT	.DB $CB,$31,$17		; SLL C\ RLA

	LD	B,(HL)
	LD	A,E
	CP	$80
	JR	C,api_sprite_drawAnd_PosY
	NEG
	CP	B
	RET	P
	LD	C,A
	NEG
	ADD	A,B
	LD	B,0
	ADD	HL,BC
	LD	E,B
	LD	B,A
api_sprite_drawAnd_PosY:
	CP	64
	RET	NC
api_sprite_drawAnd_ClipBtm:
	ADD	A,B
	SUB	65
	JR	C,api_sprite_drawAnd_DoHoriz
	SUB	B
	CPL
	LD	B,A
api_sprite_drawAnd_DoHoriz:
	LD	A,D
	CP	$80
	JR	C,api_sprite_drawAnd_PosX
	CP	-7
	RET	C
	LD	IX,api_sprite_drawAnd_ClipLeft
	JR	api_sprite_drawAnd_Patch
api_sprite_drawAnd_PosX:
	CP	96
	RET	NC
	CP	89
	LD	IX,api_sprite_drawAnd_ClipRight
	JR	C,api_sprite_drawAnd_DoSprite
api_sprite_drawAnd_Patch:
	LD	(IX),0
api_sprite_drawAnd_DoSprite:
	DI
	INC	HL
	PUSH	HL
	SLA	E
	SLA	E
	LD	H,0
	LD	L,E
	LD	D,H
	ADD	HL,HL
	ADD	HL,DE
	LD	E,A
	SRA	E
	SRA	E
	SRA	E
	JP	P,api_sprite_drawAnd_Pos
	DEC	D
api_sprite_drawAnd_Pos:
	ADD	HL,DE
	LD	DE,PlotSScreen
	ADD	HL,DE
	POP	DE
	AND	7
	LD	(api_sprite_drawAnd_save),SP
	LD	SP,11
	JR	Z,api_sprite_drawAnd_Aligned
	DEC	A
	LD	C,A
	ADD	A,A
	ADD	A,C
	LD	(api_sprite_drawAnd_Jump),A
api_sprite_drawAnd_Loop:
	LD	A,(DE)
	LD	C,A
	LD	A,$FF
api_sprite_drawAnd_Jump	=$+1
	JR	$
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	A_PIXEL_SHIFT
	AND	(HL)
api_sprite_drawAnd_ClipLeft:
	LD	(HL),A
	INC	HL
	LD	A,C
	AND	(HL)
api_sprite_drawAnd_ClipRight:
	LD	(HL),A
	INC	DE
	ADD	HL,SP
	DJNZ	api_sprite_drawAnd_Loop
	LD	(IX),$77
api_sprite_drawAnd_Done:
api_sprite_drawAnd_save	=$+1
	LD	SP,0
	RET
api_sprite_drawAnd_Aligned:
	INC	SP
api_sprite_drawAnd_ALoop:
	LD	A,(DE)
	AND	(HL)
	LD	(HL),A
	INC	DE
	ADD	HL,SP
	DJNZ	api_sprite_drawAnd_ALoop
	JP	api_sprite_drawAnd_Done

#ENDIF
#ENDIF

; ***
; [routine]sprite.drawOr(&#8594;sprite,%pos)[/routine]
;
; ORs a sprite at <i>sprite</i> with plotsscreen at position <i>pos</i>. <i>pos</i> is a double byte with the first byte (MSB) being the x-coord and the second byte (LSB) being the y-coord. Sprite data should be in this format:
;
; <kbd>sprite:
;  .db number_of_rows
;  .db row_1
;  .db row_2
;  ...
;  .db row_N</kbd>
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Sean McLaughlin
;    (Taken from the "Best Damn Sprite Routines Period" package)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   sprite.drawOr(sprite,pos) load(hl,sprite)
   #DEFCONT  \ load(de,pos)
   #DEFCONT  \ call api_sprite_drawOr
   #DEFCONT  \ #DEFINE api_use_sprite_drawOr

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_sprite_drawOr

api_sprite_drawOr:

   ; hl = sprite
   ; de = pos

   #define	O_PIXEL_SHIFT	.DB $CB,$21,$17		; SLA C\ RLA

	LD	B,(HL)
	LD	A,E
	CP	$80
	JR	C,api_sprite_drawOr_PosY
	NEG
	CP	B
	RET	P
	LD	C,A
	NEG
	ADD	A,B
	LD	B,0
	ADD	HL,BC
	LD	E,B
	LD	B,A
api_sprite_drawOr_PosY:
	CP	64
	RET	NC
api_sprite_drawOr_ClipBtm:
	ADD	A,B
	SUB	65
	JR	C,api_sprite_drawOr_DoHoriz
	SUB	B
	CPL
	LD	B,A
api_sprite_drawOr_DoHoriz:
	LD	A,D
	CP	$80
	JR	C,api_sprite_drawOr_PosX
	CP	-7
	RET	C
	LD	IX,api_sprite_drawOr_ClipLeft
	JR	api_sprite_drawOr_Patch
api_sprite_drawOr_PosX:
	CP	96
	RET	NC
	CP	89
	LD	IX,api_sprite_drawOr_ClipRight
	JR	C,api_sprite_drawOr_DoSprite
api_sprite_drawOr_Patch:
	LD	(IX),0
api_sprite_drawOr_DoSprite:
	DI
	INC	HL
	PUSH	HL
	SLA	E
	SLA	E
	LD	H,0
	LD	L,E
	LD	D,H
	ADD	HL,HL
	ADD	HL,DE
	LD	E,A
	SRA	E
	SRA	E
	SRA	E
	JP	P,api_sprite_drawOr_Pos
	DEC	D
api_sprite_drawOr_Pos:
	ADD	HL,DE
	LD	DE,PlotSScreen
	ADD	HL,DE
	POP	DE
	AND	7
	LD	(api_sprite_drawOr_save),SP
	LD	SP,11
	JR	Z,api_sprite_drawOr_Aligned
	DEC	A
	LD	C,A
	ADD	A,A
	ADD	A,C
	LD	(api_sprite_drawOr_Jump),A
api_sprite_drawOr_Loop:
	LD	A,(DE)
	LD	C,A
	XOR	A
api_sprite_drawOr_Jump	=$+1
	JR	$
	O_PIXEL_SHIFT
	O_PIXEL_SHIFT
	O_PIXEL_SHIFT
	O_PIXEL_SHIFT
	O_PIXEL_SHIFT
	O_PIXEL_SHIFT
	O_PIXEL_SHIFT
	OR	(HL)
api_sprite_drawOr_ClipLeft:
	LD	(HL),A
	INC	HL
	LD	A,C
	OR	(HL)
api_sprite_drawOr_ClipRight:
	LD	(HL),A
	INC	DE
	ADD	HL,SP
	DJNZ	api_sprite_drawOr_Loop
	LD	(IX),$77
api_sprite_drawOr_Done:
api_sprite_drawOr_save	=$+1
	LD	SP,0
	RET
api_sprite_drawOr_Aligned:
	INC	SP
api_sprite_drawOr_ALoop:
	LD	A,(DE)
	OR	(HL)
	LD	(HL),A
	INC	DE
	ADD	HL,SP
	DJNZ	api_sprite_drawOr_ALoop
	JP	api_sprite_drawOr_Done

#ENDIF
#ENDIF

; ***
; [routine]sprite.drawXor(&#8594;sprite,%pos)[/routine]
;
; XORs a sprite at <i>sprite</i> with plotsscreen at position <i>pos</i>. <i>pos</i> is a double byte with the first byte (MSB) being the x-coord and the second byte (LSB) being the y-coord. Sprite data should be in this format:
;
; <kbd>sprite:
;  .db number_of_rows
;  .db row_1
;  .db row_2
;  ...
;  .db row_N</kbd>
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Sean McLaughlin
;    (Taken from the "Best Damn Sprite Routines Period" package)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   sprite.drawXor(sprite,pos) load(hl,sprite)
   #DEFCONT  \ load(de,pos)
   #DEFCONT  \ call api_sprite_drawXor
   #DEFCONT  \ #DEFINE api_use_sprite_drawXor

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_sprite_drawXor

api_sprite_drawXor:

   ; hl = sprite
   ; de = pos

   #define	X_PIXEL_SHIFT	.DB $CB,$21,$17		; SLA C\ RLA

	LD	B,(HL)
	LD	A,E
	CP	$80
	JR	C,api_sprite_drawXor_PosY
	NEG
	CP	B
	RET	P
	LD	C,A
	NEG
	ADD	A,B
	LD	B,0
	ADD	HL,BC
	LD	E,B
	LD	B,A
api_sprite_drawXor_PosY:
	CP	64
	RET	NC
api_sprite_drawXor_ClipBtm:
	ADD	A,B
	SUB	65
	JR	C,api_sprite_drawXor_DoHoriz
	SUB	B
	CPL
	LD	B,A
api_sprite_drawXor_DoHoriz:
	LD	A,D
	CP	$80
	JR	C,api_sprite_drawXor_PosX
	CP	-7
	RET	C
	LD	IX,api_sprite_drawXor_ClipLeft
	JR	api_sprite_drawXor_Patch
api_sprite_drawXor_PosX:
	CP	96
	RET	NC
	CP	89
	LD	IX,api_sprite_drawXor_ClipRight
	JR	C,api_sprite_drawXor_DoSprite
api_sprite_drawXor_Patch:
	LD	(IX),0
api_sprite_drawXor_DoSprite:
	DI
	INC	HL
	PUSH	HL
	SLA	E
	SLA	E
	LD	H,0
	LD	L,E
	LD	D,H
	ADD	HL,HL
	ADD	HL,DE
	LD	E,A
	SRA	E
	SRA	E
	SRA	E
	JP	P,api_sprite_drawXor_Pos
	DEC	D
api_sprite_drawXor_Pos:
	ADD	HL,DE
	LD	DE,PlotSScreen
	ADD	HL,DE
	POP	DE
	AND	7
	LD	(api_sprite_drawXor_save),SP
	LD	SP,11
	JR	Z,api_sprite_drawXor_Aligned
	DEC	A
	LD	C,A
	ADD	A,A
	ADD	A,C
	LD	(api_sprite_drawXor_Jump),A
api_sprite_drawXor_Loop:
	LD	A,(DE)
	LD	C,A
	XOR	A
api_sprite_drawXor_Jump	=$+1
	JR	$
	X_PIXEL_SHIFT
	X_PIXEL_SHIFT
	X_PIXEL_SHIFT
	X_PIXEL_SHIFT
	X_PIXEL_SHIFT
	X_PIXEL_SHIFT
	X_PIXEL_SHIFT
	XOR	(HL)
api_sprite_drawXor_ClipLeft:
	LD	(HL),A
	INC	HL
	LD	A,C
	XOR	(HL)
api_sprite_drawXor_ClipRight:
	LD	(HL),A
	INC	DE
	ADD	HL,SP
	DJNZ	api_sprite_drawXor_Loop
	LD	(IX),$77
api_sprite_drawXor_Done:
api_sprite_drawXor_save	=$+1
	LD	SP,0
	RET
api_sprite_drawXor_Aligned:
	INC	SP
api_sprite_drawXor_ALoop:
	LD	A,(DE)
	XOR	(HL)
	LD	(HL),A
	INC	DE
	ADD	HL,SP
	DJNZ	api_sprite_drawXor_ALoop
	JP	api_sprite_drawXor_Done

#ENDIF
#ENDIF

; ***
; [routine]sprite.drawMask(&#8594;sprite,%pos)[/routine]
;
; XORs, then ANDs a sprite at <i>sprite</i> with plotsscreen at position <i>pos</i>. <i>pos</i> is a double byte with the first byte (MSB) being the x-coord and the second byte (LSB) being the y-coord. Sprite data should be in this format:
;
; <kbd>sprite:
;  .db number_of_rows
;  .db row_1, row_1_mask
;  .db row_2, row_2_mask
;  ...
;  .db row_N, row_N_mask</kbd>
;
; Note that the first byte is the data to be XOR'ed, the second is the data to be AND'ed.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Sean McLaughlin
;    (Taken from the "Best Damn Sprite Routines Period" package)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   sprite.drawMask(sprite,pos) load(hl,sprite)
   #DEFCONT  \ load(de,pos)
   #DEFCONT  \ call api_sprite_drawMask
   #DEFCONT  \ #DEFINE api_use_sprite_drawMask

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_sprite_drawMask

api_sprite_drawMask:

   ; hl = sprite
   ; de = pos

   #define	M_PIXEL_SHIFT	.DB $CB,$31,$17,$29	; SLL C\  RLA\  ADD HL,HL

	LD	B,(HL)
	LD	A,E
	CP	$80
	JR	C,api_sprite_drawMask_PosY
	NEG
	CP	B
	RET	P
	LD	C,A
	NEG
	ADD	A,B
	LD	B,0
	SLA	C
	ADD	HL,BC
	LD	E,B
	LD	B,A
api_sprite_drawMask_PosY:
	CP	64
	RET	NC
api_sprite_drawMask_ClipBtm:
	ADD	A,B
	SUB	65
	JR	C,api_sprite_drawMask_DoHoriz
	SUB	B
	CPL
	LD	B,A
api_sprite_drawMask_DoHoriz:
	LD	A,D
	CP	$80
	JR	C,api_sprite_drawMask_PosX
	CP	-7
	RET	C
	LD	IX,api_sprite_drawMask_ClipLeft
	JR	api_sprite_drawMask_Patch
api_sprite_drawMask_PosX:
	CP	96
	RET	NC
	CP	89
	LD	IX,api_sprite_drawMask_ClipRight
	JR	C,api_sprite_drawMask_DoSprite
api_sprite_drawMask_Patch:
	LD	(IX),0
api_sprite_drawMask_DoSprite:
	DI
	INC	HL
	LD	(api_sprite_drawMask_save),SP
	LD	SP,HL
	SLA	E
	SLA	E
	LD	L,E
	LD	H,0
	LD	D,H
	ADD	HL,HL
	ADD	HL,DE
	LD	E,A
	SRA	E
	SRA	E
	SRA	E
	JP	P,api_sprite_drawMask_Pos
	DEC	D
api_sprite_drawMask_Pos:
	ADD	HL,DE
	LD	DE,PlotSScreen
	ADD	HL,DE

	AND	7
	JR	Z,api_sprite_drawMask_Aligned
	DEC	A
	ADD	A,A
	ADD	A,A
	LD	(api_sprite_drawMask_Jump),A

api_sprite_drawMask_Loop:
	POP	DE
	XOR	A
	LD	C,D
	LD	D,A
	DEC	A
	EX	DE,HL
api_sprite_drawMask_Jump	=$+1
	JR	$
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	EX	DE,HL
	AND	(HL)
	XOR	D
api_sprite_drawMask_ClipLeft:
	LD	(HL),A
	INC	HL
	LD	A,C
	AND	(HL)
	XOR	E
api_sprite_drawMask_ClipRight:
	LD	(HL),A
	LD	DE,11
	ADD	HL,DE
	DJNZ	api_sprite_drawMask_Loop
	LD	(IX),$77
api_sprite_drawMask_Done:
api_sprite_drawMask_save	=$+1
	LD	SP,0
	RET

api_sprite_drawMask_Aligned:
	LD	DE,12
	LD	A,B
api_sprite_drawMask_ALoop:
	POP	BC
	EX	AF,AF'
	LD	A,(HL)
	AND	B
	XOR	C
	LD	(HL),A
	ADD	HL,DE
	EX	AF,AF'
	DEC	A
	JP	NZ,api_sprite_drawMask_ALoop
	JP	api_sprite_drawMask_Done

#ENDIF
#ENDIF

; ***
; <b><font size=4>Mathematics</font></b>
;

; ***
; [routine]math.sqrt(%val)[/routine]
;
; Returns the square root of <i>val</i> in a. This routine was optimized for speed, not for size. It runs in under 900 clocks according to Jim.
;
; Example:
;  math.sqrt(9)
;  ; a = 3
;  ld c,9
;  math.sqrt(c)
;  ; a = 3
;
; Size:
;  180 bytes routine + 6 bytes invocation
;
; Written by:
;  James Montelongo (Jim e)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   math.sqrt(val) load(de,val)
   #DEFCONT  \ call api_math_sqrt
   #DEFCONT  \ #DEFINE api_use_math_sqrt

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_math_sqrt

api_math_sqrt:

   ; de = val

   xor a
   ld h,a
   ld l,a
   ld b,a
   rl d
   rl l
   rl d
   rl l
   ld c,1
   sbc hl,bc
   jp c,$+3+2+1
   sbc hl,bc
   inc a
   add hl,bc
   add a,a
   rl d
   rl l
   rl d
   rl l
   ld c,a
   scf
   rl c
   sbc hl,bc
   jp c,$+3+2+1
   sbc hl,bc
   inc a
   add hl,bc
   add a,a
   rl d
   rl l
   rl d
   rl l
   ld c,a
   scf
   rl c
   sbc hl,bc
   jp c,$+3+2+1
   sbc hl,bc
   inc a
   add hl,bc
   add a,a
   rl d
   rl l
   rl d
   rl l
   ld c,a
   scf
   rl c
   sbc hl,bc
   jp c,$+3+2+1
   sbc hl,bc
   inc a
   add hl,bc
   add a,a
   rl e
   adc hl,hl
   rl e
   adc hl,hl
   ld c,a
   scf
   rl c
   sbc hl,bc
   jp c,$+3+2+1
   sbc hl,bc
   inc a
   add hl,bc
   add a,a
   rl e
   adc hl,hl
   rl e
   adc hl,hl
   ld c,a
   scf
   rl c
   sbc hl,bc
   jp c,$+3+2+1
   sbc hl,bc
   inc a
   add hl,bc
   add a,a
   rl e
   adc hl,hl
   rl e
   adc hl,hl
   ld c,a
   scf
   rl c
   sbc hl,bc
   jp c,$+3+2+1
   sbc hl,bc
   inc a
   add hl,bc
   add a,a
   rl e
   adc hl,hl
   rl e
   adc hl,hl
   ld c,a
   scf
   rl c
   rl b
   sbc hl,bc
   jp c,$+3+2+1
   sbc hl,bc
   inc a
   add hl,bc
   ret

#ENDIF
#ENDIF

; ***
; [routine]math.multiply(#val1,#val2)[/routine]
;
; Multiplies <i>val1</i> with <i>val2</i>, result returned in hl.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Konrad Meyer
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   math.multiply(val1,val2) load(a,val1)
   #DEFCONT  \ load(e,val2)
   #DEFCONT  \ call api_math_multiply
   #DEFCONT  \ #DEFINE api_use_math_multiply

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_math_multiply

api_math_multiply:

   ; a = val1
   ; e = val2

	CP	E
	JR	C,api_math_multiply_bigger
api_math_multiply_EisSmaller:
	LD	C,E
	LD	E,A
	LD	A,C
api_math_multiply_bigger:
	LD	D,0
	LD	HL,0
	LD	B,8
api_math_multiply_Multloop:
	BIT	0,A
	JR	Z,api_math_multiply_dontadd
	ADD	HL,DE
api_math_multiply_dontadd:
	SRL	A
	SLA	E
	RL	D
	DJNZ	api_math_multiply_Multloop
	RET

#ENDIF
#ENDIF

; ***
; [routine]math.random(#val)[/routine]
;
; Generates a random number LESS THAN the input in A.
;
; Example:
;  math.random(200)
;
; Size:
; 10 + 20 + 36 bytes routine + 5 bytes invocation
;
; Depends on:
;  math.rand()
;  math.mul8(h,e) 
;
; Written by:
;  James montelongo
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   math.random(val) load(a,val)
   #DEFCONT  \ call api_math_random
   #DEFCONT  \ #DEFINE api_use_math_random

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_math_random

   #DEFINE api_use_math_mul8
   #DEFINE api_use_math_rand

api_math_random:
	ld	e,a
	call	api_math_rand
	ld	h,a
	call	api_math_mul8
	ld	a,h
	ret

#ENDIF
#ENDIF

; ***
; [routine]math.mul8(#val1,#val2)[/routine]
;
; Multiply two 8BIT values and return in HL.
;
; Example:
;  math.mul8(a,234)
;
; Size:
;  36 bytes routine + 7 bytes invocation
;
; Written by:
;  z80bits
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   math.mul8(val1,val2) load(h,val1)
   #DEFCONT  \ load(e,val2)
   #DEFCONT  \ call api_math_mul8
   #DEFCONT  \ #DEFINE api_use_math_mul8

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_math_mul8

api_math_mul8:
    ld  d,0
    ld  l,d
    sla h           ; optimised 1st iteration
    jr  nc,$+3
    ld  l,e
    add hl,hl       ; unroll 7 times
    jr  nc,$+3      ; ...
    add hl,de       ; ...
    add hl,hl       ; unroll 7 times
    jr  nc,$+3      ; ...
    add hl,de       ; ...
    add hl,hl       ; unroll 7 times
    jr  nc,$+3      ; ...
    add hl,de       ; ...
    add hl,hl       ; unroll 7 times
    jr  nc,$+3      ; ...
    add hl,de       ; ...
    add hl,hl       ; unroll 7 times
    jr  nc,$+3      ; ...
    add hl,de       ; ...
    add hl,hl       ; unroll 7 times
    jr  nc,$+3      ; ...
    add hl,de       ; ...
    add hl,hl       ; unroll 7 times
    ret nc          ; ...
    add hl,de       ; ...
    ret

#ENDIF
#ENDIF

; ***
; [routine]math.div8(#val1,#val2)[/routine]
;
;   C divided by E equals C and remainder A
;
; Example:
;  math.div8(a,3)
;
; Size:
;  14 bytes routine + ?? bytes invocation
;
; Written by:
;  james montelongo
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   math.div8(val1,val2) load(c,val1)
   #DEFCONT  \ load(e,val2)
   #DEFCONT  \ call api_math_div8
   #DEFCONT  \ #DEFINE api_use_math_div8

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_math_div8

api_math_div8:
	xor a
	ld b,8
math_div8_loop:
	rl c
	rla
	cp e
	jr c,math_div8_skip
	sub e
	inc c
math_div8_skip:
	djnz math_div8_loop
	ret


#ENDIF
#ENDIF

; ***
; [routine]math.rand()[/routine]
;
; Returns a random 8 bit number in A.
;
; Example:
;  math.rand()
;
; Size:
;  20 bytes routine + 3 bytes invocation
;
;WARNING:
;Requires 2 bytes of storage for the seed under randdata.
;
;
; Written by:
;  Joe Wingbermuehle from ION
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   math.rand() call api_math_rand
   #DEFCONT  \ #DEFINE api_use_math_rand

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_math_rand

api_math_rand:
	push	hl
	push	de
	ld	hl,(randData)
	ld	a,r
	ld	d,a
	ld	e,(hl)
	add	hl,de
	add	a,l
	xor	h
	ld	(randData),hl
	pop	de
	pop	hl
	ret
randData:
 .dw 0

#ENDIF
#ENDIF

; ***
; [routine]math.mul16(%val1,%val2)[/routine]
;
; BC x DE = BCHL
;
; Example:
;  math.mul16(513,1000)
;
;
;NOT TESTED!!!
;
; Size:
;  20 bytes routine + 9 bytes invocation
;
; Written by:
;  james montelongo
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   math.mul16(val1,val2) load(bc,val1)
   #DEFCONT  \ load(de,val2)
   #DEFCONT  \ call api_math_mul16
   #DEFCONT  \ #DEFINE api_use_math_mul16

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_math_mul16

api_math_mul16:
    ld  hl,0
    ld  a,16
api_mul16_loop:
    add hl,hl
    rl  c
    rl  b
    jr  nc,api_mul16_noadd
    add hl,de   
    jr  nc,api_mul16_noadd
    inc bc
api_mul16_noadd:
    dec a
    jr  nz,api_mul16_loop
    ret

#ENDIF
#ENDIF

; ***
; <b><font size=4>Integer</font></b>
;

; ***
; [routine]int.toString(&#8594;str,#val)[/routine]
;
; Format value <i>val</i> to a string at <i>str</i>. String will be in hexadecimal form.
;
; Example:
;  int.toString(saferam1,5)  ; To format value 5
;  int.toString(saferam1,c)  ; To format value in c
;  home.print(text)
;  home.println(saferam1)
;  ...
;  text: .db "Value: ",0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   int.toString(str,val) load(hl,str)
   #DEFCONT  \ load(a,val)
   #DEFCONT  \ call api_int_toString
   #DEFCONT  \ #DEFINE api_use_int_toString

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_int_toString

api_int_toString:

   ; hl = str
   ; a = val

   ld (hl),'#'
   inc hl
   ld b,a
   srl a
   srl a
   srl a
   srl a
   call api_int_toString_tochar
   ld (hl),a
   inc hl
   ld a,b
   and %00001111
   call api_int_toString_tochar
   ld (hl),a
   inc hl
   ld (hl),0
   ret

api_int_toString_tochar:
   add a,$30
   cp $3a
   ret c
   add a,7
   ret

#ENDIF
#ENDIF

; ***
; [routine]int.decToString(&#8594;str,#val)[/routine]
;
; Format value <i>val</i> to a string at <i>str</i>. String will be in decimal form.
;
; Example:
;  int.decToString(saferam1,5)  ; To format value 5
;  int.decToString(saferam1,c)  ; To format value in c
;  home.print(text)
;  home.println(saferam1)
;  ...
;  text: .db "Value: ",0
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Ben Ryves
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   int.decToString(str,val) load(hl,str)
   #DEFCONT  \ load(a,val)
   #DEFCONT  \ call api_int_decToString
   #DEFCONT  \ #DEFINE api_use_int_decToString

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_int_decToString

api_int_decToString:

   ; hl = str
   ; a = val

   ld b,0
api_int_decToString_100:
   cp 100   ; > 100?
   jr c,api_int_decToString_s_100
   inc b
   sub 100
   jr api_int_decToString_100
api_int_decToString_s_100:
   push af
   ld a,b
   or a
   jr z,api_int_decToString_s_n_100
   add a,'0'
   ld (hl),a
   inc hl
api_int_decToString_s_n_100:
   pop af   


   ld b,0
api_int_decToString_10:
   cp 10   ; > 10?
   jr c,api_int_decToString_s_10
   inc b
   sub 10
   jr api_int_decToString_10
api_int_decToString_s_10:
   push af
   ld a,b
   or a
   jr z,api_int_decToString_s_n_10
   add a,'0'
   ld (hl),a
   inc hl
api_int_decToString_s_n_10:
   pop af
   add a,'0'
   ld (hl),a
   inc hl
   ld (hl),0
   ret

#ENDIF
#ENDIF

; ***
; <b><font size=4>Other</font></b>
;

; ***
; [routine]Increase(&#8594;Pointer)[/routine]
;
; Increases a value by one.
;
; Example:
;  Increase(Highscore)
; or
;  inc(Highscore)
;  ...
;  Highscore: .db 0
;
; Written by:
;  Robert Kuhf
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   Increase(Pointer) load(hl,Pointer)
   #DEFCONT  \ inc (hl)

   #DEFINE   inc(Pointer) load(hl,Pointer)
   #DEFCONT  \ inc (hl)

#ENDIF
#ENDIF

; ***
; [routine]load(reg,val)[/routine]
;
; Loads a value or a register <i>val</i> in register <i>reg</i>.
;
; <i>It is recommended that (within this API) this macro is only used in other macro definitions where the input is variable, not in API routines! The API should stay compatible with TASM as much as possible!</i>
;
; In TASM, this macro will just compile to
;<kbd>  ld reg,val</kbd>
; but when compiled with Brass, exceptions will assure that things like these work too:
;<kbd>  load(bc,a)
;  load(hl,ix)
;  load(ix,iyh)</kbd>
; and that things like these will be optimized:
;<kbd>  load(h,h)   compiles to nothing
;  load(a,0)   compiles to xor a</kbd>
;
; <b>Note:</b> In some special cases like these:
;<kbd>  load(h,ixh)
;  load(iy,hl)</kbd>
; the neccessary exception macro's will use register <i>a</i> or the stack as a temporary storage.
;
; Written by:
;  Timendus
;

   ;****************************************
   ; TASM/default define

#define load(reg,val) ld reg,val

   ;****************************************
   ; Exceptions for single registers

#define load({a},{0}) xor a

#define load({a},{a})
#define load({b},{b})
#define load({c},{c})
#define load({d},{d})
#define load({e},{e})
#define load({h},{h})
#define load({l},{l})
#define load({ixh},{ixh})
#define load({ixl},{ixl})
#define load({iyh},{iyh})
#define load({iyl},{iyl})

#define load({h},{ixh}) ld a,ixh \ ld h,a
#define load({h},{ixl}) ld a,ixl \ ld h,a
#define load({h},{iyh}) ld a,iyh \ ld h,a
#define load({h},{iyl}) ld a,iyl \ ld h,a

#define load({l},{ixh}) ld a,ixh \ ld l,a
#define load({l},{ixl}) ld a,ixl \ ld l,a
#define load({l},{iyh}) ld a,iyh \ ld l,a
#define load({l},{iyl}) ld a,iyl \ ld l,a

#define load({ixh},{h}) ld a,h \ ld ixh,a
#define load({ixh},{l}) ld a,l \ ld ixh,a
#define load({ixl},{h}) ld a,h \ ld ixl,a
#define load({ixl},{l}) ld a,l \ ld ixl,a

#define load({iyh},{h}) ld a,h \ ld iyh,a
#define load({iyh},{l}) ld a,l \ ld iyh,a
#define load({iyl},{h}) ld a,h \ ld iyl,a
#define load({iyl},{l}) ld a,l \ ld iyl,a

   ;****************************************
   ; Exceptions for HL

#define load({hl},{hl})

#define load({hl},{a}) ld h,0 \ ld l,a
#define load({hl},{b}) ld h,0 \ ld l,b
#define load({hl},{c}) ld h,0 \ ld l,c
#define load({hl},{d}) ld h,0 \ ld l,d
#define load({hl},{e}) ld h,0 \ ld l,e
#define load({hl},{h}) ld l,h \ ld h,0
#define load({hl},{l}) ld h,0
#define load({hl},{ixh}) load(hl,ix) \ ld l,h \ ld h,0
#define load({hl},{ixl}) load(hl,ix) \ ld h,0
#define load({hl},{iyh}) load(hl,iy) \ ld l,h \ ld h,0
#define load({hl},{iyl}) load(hl,iy) \ ld h,0

#define load({hl},{de}) ld h,d \ ld l,e
#define load({hl},{bc}) ld h,b \ ld l,c
#define load({hl},{ix}) push ix \ pop hl
#define load({hl},{iy}) push iy \ pop hl

   ;****************************************
   ; Exceptions for DE

#define load({de},{de})

#define load({de},{a}) ld d,0 \ ld e,a
#define load({de},{b}) ld d,0 \ ld e,b
#define load({de},{c}) ld d,0 \ ld e,c
#define load({de},{d}) ld e,d \ ld d,0
#define load({de},{e}) ld d,0
#define load({de},{h}) ld d,0 \ ld e,h
#define load({de},{l}) ld d,0 \ ld e,l
#define load({de},{ixh}) ld d,0 \ ld e,ixh
#define load({de},{ixl}) ld d,0 \ ld e,ixl
#define load({de},{iyh}) ld d,0 \ ld e,iyh
#define load({de},{iyl}) ld d,0 \ ld e,iyl

#define load({de},{hl}) ld d,h \ ld e,l
#define load({de},{bc}) ld d,b \ ld e,c
#define load({de},{ix}) ld d,ixh \ ld e,ixl
#define load({de},{iy}) ld d,iyh \ ld e,iyl

   ;****************************************
   ; Exceptions for BC

#define load({bc},{bc})

#define load({bc},{a}) ld b,0 \ ld c,a
#define load({bc},{b}) ld c,b \ ld b,0
#define load({bc},{c}) ld b,0
#define load({bc},{d}) ld b,0 \ ld c,d
#define load({bc},{e}) ld b,0 \ ld c,e
#define load({bc},{h}) ld b,0 \ ld c,h
#define load({bc},{l}) ld b,0 \ ld c,l
#define load({bc},{ixh}) ld b,0 \ ld c,ixh
#define load({bc},{ixl}) ld b,0 \ ld c,ixl
#define load({bc},{iyh}) ld b,0 \ ld c,iyh
#define load({bc},{iyl}) ld b,0 \ ld c,iyl

#define load({bc},{hl}) ld b,h \ ld c,l
#define load({bc},{de}) ld b,d \ ld c,e
#define load({bc},{ix}) ld b,ixh \ ld c,ixl
#define load({bc},{iy}) ld b,iyh \ ld c,iyl

   ;****************************************
   ; Exceptions for IX

#define load({ix},{ix})

#define load({ix},{a}) ld ixh,0 \ ld ixl,a
#define load({ix},{b}) ld ixh,0 \ ld ixl,b
#define load({ix},{c}) ld ixh,0 \ ld ixl,c
#define load({ix},{d}) ld ixh,0 \ ld ixl,d
#define load({ix},{e}) ld ixh,0 \ ld ixl,e
#define load({ix},{ixh}) ld ixl,ixh \ ld ixh,0
#define load({ix},{ixl}) ld ixh,0
#define load({ix},{iyh}) load(ix,iy) \ load(ix,ixh)
#define load({ix},{iyl}) load(ix,iy) \ load(ix,ixl)

#define load({ix},{hl}) push hl \ pop ix
#define load({ix},{de}) ld ixh,d \ ld ixl,e
#define load({ix},{bc}) ld ixh,b \ ld ixl,c
#define load({ix},{iy}) push iy \ pop ix

   ;****************************************
   ; Exceptions for IY

#define load({iy},{iy})

#define load({iy},{a}) ld iyh,0 \ ld iyl,a
#define load({iy},{b}) ld iyh,0 \ ld iyl,b
#define load({iy},{c}) ld iyh,0 \ ld iyl,c
#define load({iy},{d}) ld iyh,0 \ ld iyl,d
#define load({iy},{e}) ld iyh,0 \ ld iyl,e
#define load({iy},{ixh}) load(iy,ix) \ load(iy,iyh)
#define load({iy},{ixl}) load(iy,ix) \ load(iy,iyl)
#define load({iy},{iyh}) ld iyl,iyh \ ld iyh,0
#define load({iy},{iyl}) ld iyh,0

#define load({iy},{hl}) push hl \ pop iy
#define load({iy},{de}) ld iyh,d \ ld iyl,e
#define load({iy},{bc}) ld iyh,b \ ld iyl,c
#define load({iy},{ix}) push ix \ pop iy

   ;****************************************
   ;****************************************

; ***
; <b><font size=4>Matrix</font></b>
;

; ***
; [routine]Definition of matrix[/routine]
;
; A matrix will be defined as follows for use in this section:
;
;<kbd> .db [width x],[height y]
; .db [data 0,0],[data 1,0],...,[data x-1,0]
; .db ...
; .db [data 0,y-1],[data 1,y-1],...,[data x-1,y-1]</kbd>
;
; So this would be a valid 5x3 matrix:
;
;<kbd> .db 5,3
; .db  1, 2, 3, 4, 5
; .db  6, 7, 8, 9,10
; .db 11,12,13,14,15</kbd>
;
; We should index the value 8 in this matrix with the coordinates (2,1).
;
; Written by:
;  Timendus
;

; ***
; <b><font size=4>Greyscale</font></b>
;

; ***
; [routine]gs.enable()[/routine]
;
; Enables the greyscale interrupt. Call this macro before you use any other greyscale routines! This version detects wether or not you are on an SE, this allows for SE owner to take advantage of the better quality grey that the SE can provide without the coders having to make seperate versions of the game. You can define "NODOUBLEBUFFER" in your source to disable the use of the double buffer and/or "VTI" to compile for VTI.
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  James Montelongo, based on the GPP by Duck
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.enable() call api_gs_enable
   #DEFCONT  \ #DEFINE api_use_gs_enable

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_enable

#IFDEF VTI
#DEFINE EMU
Frame_skip = 2
#ELSE
Frame_skip = 3
#ENDIF

#IFDEF API_TI83
interrupt_entry =$8787
interrupt_byte	=$87
interrupt_table =$8600
interrupt_reg	=$86
#ENDIF
#IFDEF API_TI83P
;uses statvars
interrupt_entry =$8a8a
interrupt_byte	=$8a
interrupt_table =$8b00
interrupt_reg	=$8b
#ENDIF

gbuf1	= plotsscreen
gbuf2	= savesscreen

#ifdef NODOUBLEBUFFER
gActivebuf1 = gbuf1
gActivebuf2 = gbuf2
#endif 

api_gs_enable:

	di
	ld a,interrupt_reg
	ld i,a
	ld hl,interrupt_table
	ld de,interrupt_table+1
	ld bc,256
	ld (hl),interrupt_byte
	ldir
	Set 7,(iy+20)

	ld hl,Intstart
	ld bc,Intend-Intstart
#IFDEF TI83P
	in a,(2)
	and %10100000
	jp z,notse		;83+se, 84+, 84+se 
#IFNDEF EMU
	in a,($29)


	call settimer
	ld hl,IntStartSE
	ld bc,IntEndSE-IntStartSE
#ENDIF
notse:
#ENDIF
	ld de,interrupt_entry
	ldir

	xor a		;Fastest speed
	out (4),a
	ld a,8
	out (3),a
	ld a,10
	out (3),a
	im 2
	ei
	ret

;-----------------------------------------------------
;This is for the SE it uses one of the crystal timers
;to sync with the refresh rate of the lcd reducing the
;noise.
#IFDEF TI83P
IntStartSE:
	push af
	ex af,af'
	push af
	in a,($32)		;THis is the work around for the halt bug
	cp $b1
	jr nc,greyintSE
	in a,(4)
	and $20 	;Timers only for grey
	jr z,GreyskipSE
greyintSE:
	exx
	ld b,13 	;this is the fine tuning
	djnz $		;15,000,000/(105*13)= 10,989
	call settimer	;sets time for next interrupt
	in a,($20)
	push af
	xor a
	out ($20),a
	call LCD
	pop af
	out ($20),a
#ifdef CONTRASTCTRL
	in a,(4)
	bit 3,a
	call z,ConKey
#ENDIF
;	xor a
;	ld hl,Gwait
;	cp (hl)
;	jr z,$+3		;for vsync and halt
;	dec (hl)
	exx
GreyskipSE:
	xor a
	out (4),a
	ld a,8
	out (3),a
	ld a,%00001110
	out (3),a
	pop af
	ex af,af'
	pop af
	ei
	ret
IntEndSE:

settimer:			;the heart of the SE routine
	xor a			;clear
	out ($30),a
	ld a,$40		;10922.67 Hz
	out ($30),a
	ld a,2		;generate interrupt
	out ($31),a
	ld a,0b0h
	out ($32),a 	;screen draws at 60-64hz 
	ret

#endif


;----------------------------------------------------
;The interupts on an 83P are usually not balance out
;But when both timers are running the 560hz timer is 
;evenly spaced and can be detected. So 1120hz timer
;is skipped, and every 3 560hz timer is skiped to get
;as close as possible to the refresh rate.

IntStart:
	push af
#IFDEF EMU
	call EMUDELAY
#ENDIF
#IFDEF TI83
	in a,(3)
#ELSE
	in a,(4)
#ENDIF
	and 2			;Timers only for grey
	jr z,Greyskip
	ld a,(skip83)
	dec a
	ld (skip83),a
	jr nz,Greyskip
	ld a,Frame_skip
	ld (skip83),a
	exx
	call LCD
#ifdef CONTRASTCTRL
#IFDEF TI83
	in a,(3)
#ELSE
	in a,(4)
#ENDIF
	bit 3,a
	call z,ConKey
#ENDIF
;	xor a
;	ld hl,Gwait
;	cp (hl)
;	jr z,$+3		;for vsync and halt
;	dec (hl)
	exx
Greyskip:
	xor a
	out (4),a
	ld a,8
	out (3),a
	ld a,%00001010
	out (3),a
	pop af
	ei
	ret
IntEnd:


#IFDEF EMU
EMUDELAY:
	push bc
	ld b,240
vtidelayloop:
#IFDEF TILEM
	push hl
	pop hl
	nop
#ENDIF
	push hl
	pop hl
	djnz vtidelayloop
	pop bc
	ret
#ENDIF

#ifdef CONTRASTCTRL
;this handles the contrast changing in the game
ConKey:
	ld a,$ff
	out (1),a
	ld a,$fd
	out (1),a
norepeat = $+1		;mask so keys won't repeat
	ld a,0
	cpl
	ld c,a
	in a,(1)
	ld (norepeat),a
	or c
	cpl
	ld c,a
	ld a,(contrast)
	rr c
	rr c
	adc a,0
	rr c
	sbc a,0
	cp 39
	jr nc,skipcontrast
	ld (contrast),a
	add a,$d8
	out ($10),a
skipcontrast:
	ld a,$ff
	out (1),a
	ret

#ENDIF


;-------------------------------------------------
;4 level Grey interlace routine
;by James Montelongo 
;148 bytes
;This is a reworked version of Ducks copy routine
;It does the exact same thing only faster.
;It's optimzed to a much finer degree in both
;speed and size. The timings between writes are
;73 here, Ducks was 77, plus he needs to push bc,
;I don't. He used EXX, but i used the SP register
;to gain speed. Finally rather than use a table I
;merely swap the masks from their locations and
;that save on memory.


#ifndef FASTER

lcd:					;61500
	ld (stacksave),sp
	ld	a,$80
	out ($10),a

	ld a,(rt3a+1)
	ld hl,rt1a+1
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld hl,rt2a+1
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld hl,rt3a+1
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld (rt4a+1),a

	ld a,(rt3b+1)
	ld hl,rt1b+1
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld hl,rt2b+1
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld hl,rt3b+1
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld (rt4b+1),a

	ld de,gActivebuf1
	ld hl,gActivebuf2
	ld a,$20
colloop:
	out ($10),a
	ex af,af'
	ex de,hl		; hl =layer1
	ld sp,12
	ld b,21
rowloop:

	ld a,(hl)		; hl =layer1
rt1a:	and %11011011
	ld c,a
	ld a,(de)
rt1b:	and %00100100
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(de)		; de =layer1
rt2a:	and %01101101
	ld c,a
	ld a,(hl)
rt2b:	and %10010010
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(hl)		; hl =layer1
rt3a:	and %10110110
	ld c,a
	ld a,(de)
rt3b:	and %01001001
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ex de,hl

	djnz rowloop

	ld a,(hl)		; hl =layer1
rt4a:	and %01011011
	ld c,a
	ld a,(de)
rt4b:	and %10100100
	or c
	out ($11),a
	ld sp,-755
	add hl,sp
	ex de,hl
	add hl,sp
	ex af,af'
	inc a
	cp $2c
	jr nz,colloop
stacksave =$+1
	ld sp,0
	ret

#else

lcd:					;58,700
	ld (stacksave),sp
	ld	a,$80
	out ($10),a

	ld a,(m3a+1)
	ld hl,m1a+1
	ld b,(hl)
	ld (hl),a
	ld (m4a+1),a
	ld (m7a+1),a
	ld (m0a+1),a
	ld a,b
	ld hl,m2a+1
	ld b,(hl)
	ld (hl),a
	ld (m5a+1),a
	ld (m8a+1),a
	ld a,b
	ld (m3a+1),a
	ld (m6a+1),a
	ld (m9a+1),a

	ld a,(contrast)
	add a,$d8
	out ($10),a


	ld a,(m3b+1)
	ld hl,m1b+1
	ld b,(hl)
	ld (hl),a
	ld (m4b+1),a
	ld (m7b+1),a
	ld (m0b+1),a
	ld a,b
	ld hl,m2b+1
	ld b,(hl)
	ld (hl),a
	ld (m5b+1),a
	ld (m8b+1),a
	ld a,b
	ld (m3b+1),a
	ld (m6b+1),a
	ld (m9b+1),a

	ld de,gActivebuf1
	ld hl,gActivebuf2
	ld a,$20
colloop:
	out ($10),a
	ex af,af'
	ex de,hl		; hl =layer1
	ld sp,12
	ld b,7
rowloop:

	ld a,(hl)		; hl =layer1
m1a:	and %11011011
	ld c,a
	ld a,(de)
m1b:	and %00100100
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(de)		; de =layer1
m2a:	and %01101101
	ld c,a
	ld a,(hl)
m2b:	and %10010010
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(hl)		; hl =layer1
m3a:	and %10110110
	ld c,a
	ld a,(de)
m3b:	and %01001001
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(de)		; de =layer1
m4a:	and %11011011
	ld c,a
	ld a,(hl)
m4b:	and %00100100
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(hl)		; hl =layer1
m5a:	and %01101101
	ld c,a
	ld a,(de)
m5b:	and %10010010
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(de)		; de =layer1
m6a:	and %10110110
	ld c,a
	ld a,(hl)
m6b:	and %01001001
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp


	ld a,(hl)		; hl =layer1
m7a:	and %11011011
	ld c,a
	ld a,(de)
m7b:	and %00100100
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(de)		; de =layer1
m8a:	and %01101101
	ld c,a
	ld a,(hl)
m8b:	and %10010010
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ld a,(hl)		; hl =layer1
m9a:	and %10110110
	ld c,a
	ld a,(de)
m9b:	and %01001001
	or c
	out ($11),a
	add hl,sp
	ex de,hl
	add hl,sp

	ex de,hl

	djnz rowloop

	ld a,(hl)		; hl =layer1
m0a:	and %01011011
	ld c,a
	ld a,(de)
m0b:	and %10100100
	or c
	out ($11),a
	ld sp,-755
	add hl,sp
	ex de,hl
	add hl,sp
	ex af,af'
	inc a
	cp $2c
	jp nz,colloop
stacksave =$+1
	ld sp,0
	ret

#endif






;---------------------------
;temp-no need to save on exit
;---------------------------


skip83:
 .db 3


ghalt:
 .db 0

#ifndef NODOUBLEBUFFER
gActivebuf1:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
gActivebuf2:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
#endif

#ENDIF
#ENDIF

; ***
; [routine]gs.disable()[/routine]
;
; Disables the greyscale interrupt. Call this macro after you used greyscale routines, before you return to the OS!
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  James Montelongo, based on the GPP by Duck
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.disable() call api_gs_disable
   #DEFCONT  \ #DEFINE api_use_gs_disable

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_disable

api_gs_disable:

	di
	im 1
	ld a,6
	out (4),a
	ld a,$0b		;regular interrupts occur
	out (3),a
#IFDEF API_TI83P
	in a,(2)
	and %10100000
	ret z
	xor a			;disable timer
	out ($30),a
#ENDIF
	ret

#ENDIF
#ENDIF

; ***
; [routine]gs.getcsc()[/routine]
;
; I stared long and hard a Ducks getk routine. Theres was alot of work for something that should have been relatively simple. So I just completely rewrote the routine. This faster and smaller. :)
;
; Example:
;  Write example
;
; Size:
;  43 bytes routine + 3 bytes invocation
;
; Depends on:
;  gs.enable()
;
; Written by:
;  James Montelongo based on the GPP by Duck
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.getcsc() call api_gs_getcsc
   #DEFCONT  \ #DEFINE api_use_gs_getcsc

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_getcsc

api_gs_getcsc:

	push hl
	push de
	push bc
	ld a,$ff		;
	out (1),a		;reset keyport
	ld e,$fe		;frist group
	ld c,$01		;key port
	ld l,0		;l holds key pressed
cscloop:
	out (c),e		;set keygroup
	ld b,8		;loop, Delay needed when work with key driver
	in a,(c)		;read key
cscbit:
	inc l			;inc to get key pressed
	rra 			; if key pressed done
	jp nc,donecsc
	djnz cscbit 	;loop 8
	rlc e			;next key group
	jp m,cscloop	;if bit 7 set loop
	ld l,0		;if no key pressed 0
donecsc:
	ld a,l		;
	or a
	ld (gs_keymem),a
	pop bc
	pop de
	pop hl
	ret

gs_keymem:
	.db 0

#ENDIF
#ENDIF

; ***
; [routine]gs.buf1ToBuf2()[/routine]
;
; Copies the first to the second greyscale buffer.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  gs.enable()
;
; Written by:
;  James Montelongo, based on the GPP by Duck
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.buf1ToBuf2() call api_gs_buf1ToBuf2
   #DEFCONT  \ #DEFINE api_use_gs_buf1ToBuf2

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_buf1ToBuf2

api_gs_buf1ToBuf2:

	ld hl,gbuf1
	ld de,gbuf2
	ld bc,768
   ;This can be used as an entry for a faster ldir routine
   ;MUST BE DIVISIBLE BY 16 BYTES, save 4000 clocks
api_gs_gsCopy:
	ldi \ ldi \ ldi \ ldi
	ldi \ ldi \ ldi \ ldi
	ldi \ ldi \ ldi \ ldi
	ldi \ ldi \ ldi \ ldi
	jp pe,gsCopy
	ret

#ENDIF
#ENDIF

; ***
; [routine]gs.copyBuffer()[/routine]
;
; Copy the contents of the double buffer (if used) to the active buffers (the screen).
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  gs.enable()
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.copyBuffer() call api_gs_copyBuffer
   #DEFCONT  \ #DEFINE api_use_gs_copyBuffer

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_copyBuffer

api_gs_copyBuffer:

#ifndef NODOUBLEBUFFER
	ld hl,gbuf1
	ld de,gActivebuf1
	ld bc,768
	call gsCopy

	ld hl,gbuf2
	ld de,gActivebuf2
	ld bc,768
	jp gsCopy
#endif

	ret

gsCopy:
	ldi \ ldi \ ldi \ ldi
	ldi \ ldi \ ldi \ ldi
	ldi \ ldi \ ldi \ ldi
	ldi \ ldi \ ldi \ ldi
	jp pe,gsCopy
	ret

#ENDIF
#ENDIF

; ***
; [routine]gs.clearBuffer()[/routine]
;
;Most people won't use the sp register
;becuase that means you can't have any
;calls or interrupts, thats not true.
;Since sp will point to buffers, it is
;safe mem to write in and won't be
;noticed by coder or user, so using it
;to clear the screen would be faster
;than ldir. 1/3 the time actually
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  gs.enable()
;
; Written by:
;  Add author(s)
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.clearBuffer() call api_gs_clearBuffer
   #DEFCONT  \ #DEFINE api_use_gs_clearBuffer

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_clearBuffer

api_gs_clearBuffer:

	ld hl,0
	ld d,h
	ld e,l
	add hl,sp
	ld bc,$2020
	ld sp,gbuf1+768
api_gs_gsCB1:
	push de
	push de 		;this clears the buf
	push de 		;in a third of the time
	push de 		;ldir does.
	push de
	push de
	push de
	push de
	push de
	push de
	push de
	push de
	djnz api_gs_gsCB1
	ld b,c
	ld sp,gbuf2+768
api_gs_gsCB2:
	push de
	push de
	push de
	push de
	push de
	push de
	push de
	push de
	push de
	push de
	push de
	push de
	djnz api_gs_gsCB2
	ld sp,hl
	ret

#ENDIF
#ENDIF

; ***
; [routine]gs.drawXor(&#8594;sprite,#height,#x,#y)[/routine]
;
; XORs a sprite at <i>sprite</i> with height <i>height</i> to the greyscale buffers at coordinates (<i>x,y</i>).
;
; Example:
;  Write example
;
; Size:
;  104 bytes routine + 12 bytes invocation
;
; Depends on:
;  Add dependencies
;
; Written by:
;  James Montelongo based on the GPP by Duck
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.drawXor(sprite,height,xpos,ypos)   load(ix,sprite)
   #DEFCONT  \ load(a,xpos)
   #DEFCONT  \ load(l,ypos)
   #DEFCONT  \ load(b,height)
   #DEFCONT  \ call api_gs_drawXor
   #DEFCONT  \ #DEFINE api_use_gs_drawXor

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_drawXor

api_gs_drawXor:

	sla l			;*2
	sla l			;*4
	ld e,l
	ld h,$00
	ld d,h
	add hl,de		;*8
	add hl,de		;*12
	ld e,a
	and $07
	xor 7
	ld (gsputrotate2),a
	add a,a
	ld (gsputrotate1),a
	ld a,$ff
gsputrotate1 = $+1
	jr $
	srl a
	srl a
	srl a
	srl a
	srl a
	srl a
	srl a
	ld (gsputmask1),a
	cpl
	ld (gsputmask2),a
	srl e
	srl e
	srl e
	add hl,de
	push hl
	ld	de,gbuf1
	add hl,de
	push bc
	ld	de,11
	call gsPutSpriteLoop1
	pop bc
	pop hl
	ld	de,gbuf2
	add hl,de
	ld	de,11
gsPutSpriteLoop1:
	ld	a,(ix)
gsputrotate2 = $+1
	jr $
	rrca
	rrca
	rrca
	rrca
	rrca
	rrca
	rrca
	ld c,a
gsputmask1 = $+1
	and 0
	xor (hl)
	ld (hl),a
	inc hl
	ld a,c
gsputmask2 = $+1
	and 0
	xor (hl)
	ld	(hl),a
	add hl,de
	inc ix
	djnz gsPutSpriteLoop1
	ret

#ENDIF
#ENDIF

; ***
; [routine]gs.drawXorLarge(&#8594;sprite, #height,#x,#y)[/routine]
;
; I have to check Duck's specs for this... Jim didn't comment it at all :P
;
; ! Will not work in it's current state !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  gs.enable()
;
; Written by:
;  James Montelongo based on the GPP by Duck
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.drawXorLarge(sprite, height,x,y)   call api_gs_drawXorLarge
   #DEFCONT  \ #DEFINE api_use_gs_drawXorLarge

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_drawXorLarge

api_gs_drawXorLarge:

gsLargeSprite:
	sla l			;*2
	sla l			;*4
	ld e,l
	ld h,$00
	ld d,h
	add hl,de		;*8
	add hl,de		;*12
	ld e,a
	and $07
	xor 7
	ld (gslargerotate2),a
	add a,a
	ld (gslargerotate1),a
	ld a,$ff
gslargerotate1 = $+1
	jr $
	srl a
	srl a
	srl a
	srl a
	srl a
	srl a
	srl a
	ld (gslargemask1),a
	cpl
	ld (gslargemask2),a
	srl e
	srl e
	srl e
	add hl,de
	ld a,c
	ld (gslargewidth),a
	ld c,b

	push hl
	ld	de,gbuf1
	add hl,de
	push bc
	call gsLargeRow
	pop bc
	pop hl
	ld	de,gbuf2
	add hl,de

gsLargeRow:
	push hl
gslargewidth = $+1
	ld b,0
gsLargemask1 = $+1
	ld d,0
gsLargeCol:
	ld a,(ix)
	inc ix
gsLargerotate2 = $+1
	jr $
	rrca
	rrca
	rrca
	rrca
	rrca
	rrca
	rrca
	ld e,a
	and d
	xor (hl)
	ld (hl),a
	inc hl
	ld a,e
gsLargemask2 = $+1
	and 0
	xor (hl)
	ld	(hl),a
	djnz gsLargeCol
	pop hl
	ld de,12
	add hl,de
	dec c
	jp nz,gsLargeRow
	ret

#ENDIF
#ENDIF

; ***
; [routine]gs.alignedXor(&#8594;sprite,#x,#y)[/routine]
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  66 bytes routine + 10 bytes invocation
;
; Depends on:
;  gs.enable()
;
; Written by:
;  James Montelongo based on the GPP by Duck
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.alignedXor(sprite,x,y) load(ix,sprite)
   #DEFCONT  \ load(a,x)
   #DEFCONT  \ load(l,y)
   #DEFCONT  \ call api_gs_alignedXor
   #DEFCONT  \ #DEFINE api_use_gs_alignedXor

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_alignedXor

api_gs_alignedXor:

   ; ix = sprite
   ; a = x
   ; l = y

	sla l			;*2
	sla l			;*4
	ld h,0
	ld b,h
	ld c,l
	add hl,bc		;*8
	add hl,bc		;*12
	ld c,a
	add hl,bc
	push hl ;now we got right spot in hl
	push ix ;tile moved to DE for speed
	pop de

	ld bc,gbuf1 ;
	add hl,bc
	ld bc,12
	call api_gs_write8
	pop hl
	ld bc,gbuf2 ;
	add hl,bc
	ld bc,12

api_gs_write8:
	ld a,(de)
	ld (hl),a
	add hl,bc
	inc de
	ld a,(de)
	ld (hl),a
	add hl,bc
	inc de
	ld a,(de)
	ld (hl),a
	add hl,bc
	inc de
	ld a,(de)
	ld (hl),a
	add hl,bc
	inc de
	ld a,(de)
	ld (hl),a
	add hl,bc
	inc de
	ld a,(de)
	ld (hl),a
	add hl,bc
	inc de
	ld a,(de)
	ld (hl),a
	add hl,bc
	inc de
	ld a,(de)
	ld (hl),a
	inc de
	ret

#ENDIF
#ENDIF

; ***
; [routine]gs.alignedMask(&#8594;sprite,#x,#y)[/routine]
;
; I optimising alot here, I got rid of the second tempsprite
; I'm making it faster were I can, As far as the main loop
; I just completely reworte it, Duck's code was very awkward.
; I dropped the size about 50 bytes and made it MUCH FASTER.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  187 bytes routine + ?? bytes invocation
;
; Depends on:
;  gs.enable()
;
; Written by:
;  James Montelongo based on the GPP by Duck
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   gs.alignedMask(sprite,x,y) load(ix,sprite)
   #DEFCONT  \ load(a,x)
   #DEFCONT  \ load(l,y)
   #DEFCONT  \ call api_gs_alignedMask
   #DEFCONT  \ #DEFINE api_use_gs_alignedMask

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_gs_alignedMask

api_gs_alignedMask:

   ; ix = sprite
   ; a = x
   ; l = y

	push hl
;---------------------------------KV83 way of commenting
;Finds the tile
	ld h,0
	ld l,a
	sla l				;clears 
	sla l				;upper bits.
	add hl,hl
	add hl,hl
	add hl,de
;---------------------------------
;copys to temp area
	ld de,gsTempSprite
	ld bc,16
	ldir
;---------------------------------
;flips it if needed
	ld c,a
	bit 6,a
	call nz,gsFlipHoriz
	bit 7,c
	call nz,gsFlipVert

	ld ix,gsTempSprite
	pop hl

;---------------------------------
;find point on buffer
	ld a,h
	ld h,0
	sla l				;*2
	sla l				;*4
	ld b,h
	ld c,l
	add hl,bc			;*8
	add hl,bc			;*12
	ld c,a
	add hl,bc			;x offset
	ld b,h
	ld c,l
	ld hl,gbuf2 
	add hl,bc			;de=layer2
	ex de,hl
	ld hl,gbuf1
	add hl,bc			;hl=layer1

;----------------------------------
;Duck wrote some of the most cryptic
;code I have ever seen. So I just deleted
;it, and wrote my own. Dark grey is
;transparent.

	ld b,8
gsMaskedSprite_loop:	;this could be made faster calling 8 times.
	push bc
#ifndef REVERSEMASK 
	ld a,(ix)		;getmask
	ld b,a			;save for later
	and (ix+8)		;strip drakgrey away
#else
	ld a,(ix+8)
	ld b,a
	and (ix)
#endif
	ld c,a			;save spr data
	ld a,(hl)		;get screen
	and b			;mask it
#ifndef REVERSEMASK 
	or c			;or black
#else
	or (ix)
#endif
	ld (hl),a		;save it
	ex de,hl		;light buffer
	ld a,(hl)		;get screen
	and b			;mask it
#ifndef REVERSEMASK 
	or (ix+8)		;or LG and black
#else
	or c
#endif
	ld (hl),a		;save it
	ld bc,12		;
	add hl,bc		;next row in buffer
	ex de,hl		;gbuf1 = hl
	add hl,bc		;next row in buffer
	inc ix			;next byte in sprite
	pop bc
	djnz gsMaskedSprite_loop
	ret

;=== horizontal sprite flip
gsFlipHoriz:
	ld de,gsTempSprite+7
	ld de,gsTempSprite
	call Horiswap
	ld de,gsTempSprite+7
	ld de,gsTempSprite
Horiswap:
	ld a,(de)
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	inc hl
	ld a,(de)
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	inc hl
	ld a,(de)
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	inc hl
	ld a,(de)
	ld b,(hl)
	ld (hl),a
	ld a,b
	ld (de),a
	ret

;=== vertical sprite flip
gsFlipVert:
	ld hl,gsTempSprite
	ld b,16
gsFlipVert_loop:
	ld c,(hl)
	xor a
	rr c
	rla
	rr c
	rla
	rr c
	rla
	rr c
	rla
	rr c
	rla
	rr c
	rla
	rr c
	rla
	rr c
	rla
	ld (hl),a
	inc hl
	djnz gsFlipVert_loop
	ret


gsTempSprite:
gsTempSprite2:
	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0

#ENDIF
#ENDIF

; ***
; <b><font size=4>Drawing</font></b>
;

; ***
; [routine]draw.circle(%pos,#radius)[/routine]
;
; Draws a circle to plotsscreen with radius <i>radius</i> and position <i>pos</i>. <i>pos</i> is a double byte with the first byte (MSB) being the x-coord and the second byte (LSB) being the y-coord.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Sean McLaughlin
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   draw.circle(pos,radius) load(de,pos)
   #DEFCONT  \ load(c,radius)
   #DEFCONT  \ call api_draw_circle
   #DEFCONT  \ #DEFINE api_use_draw_circle

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_draw_circle

api_draw_circle:

   ; de = pos
   ; c = radius

	LD	A,C	;
	OR	A	;
	RET	Z	;
	RET	M	;
	LD	(api_draw_circle_x),DE	;
	LD	B,0	; B = y
	LD	H,B	;
	LD	L,C	;
	ADD	HL,HL	;
	LD	DE,3	;
	EX	DE,HL	;
	SBC	HL,DE	;
	DI		;
api_draw_circle_loop:			;
api_draw_circle_x .equ $+1		;
	LD	DE,0	; DE = (xc,yc)
	LD	A,C	; A = x
	CP	B	; nc if (x <= y)
	RET	C	;
;PSet(xc + x, yc + y)	;
	LD	A,E	; A = yc
	ADD	A,B	; A = yc + y
	LD	E,A	; E = yc + y
	EX	AF,AF'	;
	LD	A,D	; A = xc
	ADD	A,C	; A = xc + x
	LD	D,A	; DE = (xc+x,yc+y)
	CALL	api_draw_circle_PSet	;
;PSet(xc + x, yc - y)	;
	LD	A,E	; A = yc + y
	SUB	B	; A = yc
	SUB	B	; A = yc - y
	LD	E,A	; DE = (xc+x,yc-y)
	CALL	api_draw_circle_PSet	;
;PSet(xc - x, yc - y)	;
	LD	A,D	; A = xc + x
	SUB	C	; A = xc
	SUB	C	; A = xc - x
	LD	D,A	; DE = (xc-x,yc-y)
	CALL	api_draw_circle_PSet	;
;PSet(xc - x, yc + y)	;
	EX	AF,AF'	;
	LD	E,A	; DE = (xc-x,yc+y)
	CALL	api_draw_circle_PSet	;
;PSet(xc + y, yc + x)	;
	LD	A,E	; A = yc + y
	SUB	B	; A = yc
	ADD	A,C	; A = yc + x
	LD	E,A	; E = yc + x
	LD	A,D	; A = xc - x
	ADD	A,C	; A = xc
	ADD	A,B	; A = xc + y
	LD	D,A	; DE = (xc+y,yc+x)
	PUSH	AF	;			[XC+Y]
	CALL	api_draw_circle_PSet	;
;PSet(xc - y, yc + x)	;
	LD	A,D	; A = xc + y
	SUB	B	; A = xc
	SUB	B	; A = xc - y
	LD	D,A	; DE = (xc-y,yc+x)
	CALL	api_draw_circle_PSet	;
;PSet(xc - y, yc - x)	;
	LD	A,E	; A = yc + x
	SUB	C	; A = yc
	SUB	C	; A = yc - x
	LD	E,A	; DE = (xc-y,yc-x)
	CALL	api_draw_circle_PSet	;
;PSet(xc + y, yc - x)	;
	POP	AF	; A = xc + y		-
	LD	D,A	; DE = (xc+y,yc-x)
	CALL	api_draw_circle_PSet	;

;if(d < 0) err += y << 2 + 6
	BIT	7,H	;
	JR	Z,api_draw_circle_PosError
	EX	DE,HL	;
	LD	H,0	;
	LD	L,B	;
	ADD	HL,HL	;
	ADD	HL,HL
	ADD	HL,DE
	LD	DE,6
	ADD	HL,DE
	INC	B
	JP	api_draw_circle_loop

api_draw_circle_PosError:
;err += (y - x) << 2 + 10: y--
	LD	DE,10
	ADD	HL,DE
	DEC	D
	LD	A,B
	SUB	C
	ADD	A,A
	RL	D
	ADD	A,A
	RL	D
	LD	E,A
	ADD	HL,DE
	INC	B
	DEC	C
	JP	api_draw_circle_loop

api_draw_circle_PixTable:	.DB	128,64,32,16,8,4,2,1

api_draw_circlePSet:
; DE = (x,y)
	LD	A,E
	OR	A
	RET	M
	CP	64
	RET	NC
	LD	A,D
	OR	A
	RET	M
	CP	96
	RET	NC
	PUSH	DE
	PUSH	HL
	SLA	E
	SLA	E
	LD	D,0
	LD	H,D
	LD	L,E
	ADD	HL,HL
	ADD	HL,DE
	LD	E,A
	SRA	E
	SRA	E
	SRA	E
	ADD	HL,DE
	LD	DE,plotsscreen
	ADD	HL,DE
	AND	7
	EX	DE,HL
	LD	HL,api_draw_circle_PixTable
	ADD	A,L
	LD	L,A
	ADC	A,H
	SUB	L
	LD	H,A
	LD	A,(DE)
	OR	(HL)
	LD	(DE),A
	POP	HL
	POP	DE
	RET

#ENDIF
#ENDIF

; ***
; [routine]draw.clippedLine(%posa,%posb)[/routine]
;
; Draws a line between two points to plotsscreen. This is a clipping routine, which means that coordinates can be off the screen. <i>posa</i> and <i>posb</i> are double bytes with the first byte (MSB) being the x-coord and the second byte (LSB) being the y-coord.
;
; ! Hasn't been tested yet !
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  draw.line
;
; Written by:
;  Badja
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   draw.clippedLine(posa,posb) load(hl,posa)
   #DEFCONT  \ load(de,posb)
   #DEFCONT  \ call api_draw_clippedLine
   #DEFCONT  \ #DEFINE api_use_draw_clippedLine

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_draw_clippedLine

   #DEFINE api_use_draw_line

api_draw_clippedLine:

   ; hl = posa
   ; de = posb

lineClipAndDrawLong:
      ld    a,d               ; compare signs of x0 and x1
      xor   h
      and   $80
      jr    z,lcd_notTooWide  ; if same, line is not too wide
      bit   7,d
      jr    z,lcd_dPositive
      ld    a,d
      neg
      add   a,h
      jr    lcd_checkWidth
lcd_dPositive:
      ld    a,h
      neg
      add   a,d
lcd_checkWidth:               ; A = |x1 - x0|
      and   $80
      jr    nz,lcd_longLine   ; check if width exceeds 128
lcd_notTooWide:
      ld    a,e               ; compare signs of y0 and y1
      xor   l
      and   $80
      jr    z,lineClipAndDraw ; if same, line is not too high
      bit   7,e
      jr    z,lcd_ePositive
      ld    a,e
      neg
      add   a,l
      jr    lcd_checkHeight
lcd_ePositive:
      ld    a,l
      neg
      add   a,e
lcd_checkHeight:              ; A = |y1 - y0|
      and   $80
      jr    z,lineClipAndDraw ; check if height exceeds 128
lcd_longLine:
      push  de                ; line is too long
      push  hl
      call  lcd_bisect        ; bisect line so rest of routine can handle it
      call  lineClipAndDraw   ; draw first half of line
      pop   de
      pop   hl
      call  lcd_bisect        ; bisect again with endpoints swapped, then draw second half
                              ; (second bisection can return a different midpoint - this
                              ; is required in case of lines being 256 pixels wide or high)

lineClipAndDraw:
      call  lcd_compOutCode
      ex    de,hl
      ld    c,b               ; C = ????, outcode0
lcd_subdivide:
      call  lcd_compOutCode   ; B = outcode0, outcode1
      ld    a,b
      or    a                 ; are both outcodes zero?
      jp    z,lineDraw        ; if so, trivial accept and draw line
      ld    a,b
      and   c                 ; is logical AND of outcodes non-zero?
      and   $0f               ; (mask off irrelevant bits)
      ret   nz                ; if so, trivial reject and return
      ld    a,b               ; failed both tests, so clip the line segment...
      and   $0f               ; at least one endpoint is off-screen, is point 1 off-screen?
      jr    nz,lcd_clip       ; if so, pick this one
      ex    de,hl             ; otherwise, the other endpoint must be off-screen, so exchange them
      ld    b,c
      ld    c,a
lcd_clip:
      push  hl
      bit   0,b
      jr    z,lcd_notBottom
      ld    b,63              ; divide line at bottom of screen (y = 63)
      jr    lcd_divideHoriz
lcd_notBottom:
      bit   1,b
      jr    z,lcd_notTop
      ld    b,0               ; divide line at top of screen (y = 0)
lcd_divideHoriz:
      push  bc
      ld    a,h
      sub   d
      ld    h,a               ; H = x1 - x0
      ld    a,d
      jr    z,lcd_vertical    ; if x1 - x0 == 0, then intersection point is x0 == A
      ld    a,l
      sub   e
      ld    c,a               ; C = y1 - y0
      ld    a,b
      sub   e
      ld    l,a               ; L = y - y0
      ld    b,c               ; B = y1 - y0
      ld    c,d               ; C = x0
      call  lcd_divideLine    ; A = x
lcd_vertical:
      pop   bc                ; B = y
      ld    d,a
      ld    e,b               ; DE = intersection point
      jr    lcd_nextPass
lcd_notTop:
      bit   2,b
      ld    b,95              ; divide line at right edge of screen (x = 95)
      jr    nz,lcd_divideVert
      ld    b,0               ; divide line at left edge of screen (x = 0)
lcd_divideVert:
      push  bc
      ld    a,l
      sub   e
      ld    l,a               ; L = y1 - y0
      ld    a,d
      jr    z,lcd_horizontal  ; if y1 - y0 == 0, then intersection point is y0 == A
      ld    a,h
      sub   d
      ld    c,a               ; C = x1 - x0
      ld    a,b
      sub   d
      ld    h,a               ; H = x - x0
      ld    b,c               ; B = x1 - x0
      ld    c,e               ; C = y0
      call  lcd_divideLine    ; A = y
lcd_horizontal:
      pop   bc                ; B = x
      ld    d,b
      ld    e,a               ; DE = intersection point
lcd_nextPass:
      ld    b,c
      pop   hl
      jr    lcd_subdivide     ; repeat process for new line segment

lcd_divideLine:               ; return A = C + H * L / B
      ld    a,h
      xor   l
      xor   b                 ; bit 7 of A = sign of H * L / B
      push  af
      bit   7,h
      jr    z,lcd_positive1
      ld    a,h
      neg
      ld    h,a
lcd_positive1:                ; H = |H|
      bit   7,l
      jr    z,lcd_positive2
      ld    a,l
      neg
      ld    l,a
lcd_positive2:                ; L = |L|
      ld    a,b
      bit   7,a
      jr    z,lcd_positive3
      neg
lcd_positive3:                ; A = |B|
      bcall(_htimesl)         ; HL = H * L
      bcall(_divhlbya)        ; HL = HL / A
      pop   af                ; bit 7 of A = sign of H * L / B
      and   $80               ; mask off irrelevent bits
      ld    a,l               ; A = result of |H| * |L| / |B|
      jr    z,lcd_positive4
      neg                     ; make result negative if necessary
lcd_positive4:
      add   a,c               ; A = C + result
      ret

lcd_compOutCode:              ; left-rotate 4-bit outcode for point DE into B
      ld    a,d
      rla
      jr    c,lcd_negative1   ; if D < 0, then D must be < 96
      rl    b
      ld    a,95
      sub   d
      rla
      jr    lcd_notNegative1
lcd_negative1:
      rl    b
      and   a
lcd_notNegative1:
      rl    b

      ld    a,e
      rla
      jr    c,lcd_negative2   ; if E < 0, then E must be < 64
      rl    b
      ld    a,63
      sub   e
      rla
      jr    lcd_notNegative2
lcd_negative2:
      rl    b
      and   a
lcd_notNegative2:
      rl    b
      ret

lcd_bisect:                   ; set (H, L) to midpoint of (D, E) and (H, L)
      ld    a,d
      sra   a
      jr    nc,lcd_even1
      inc   a                 ; over-compensate for truncation on D only (valid)
lcd_even1:
      sra   h
      add   a,h
      ld    h,a               ; H = D/2 + H/2
      ld    a,e
      sra   a
      jr    nc,lcd_even2
      inc   a                 ; over-compensate for truncation on E only (valid)
lcd_even2:
      sra   l
      add   a,l
      ld    l,a               ; L = E/2 + L/2
      ret

#ENDIF
#ENDIF

; ***
; [routine]draw.line(%posa,%posb)[/routine]
;
; Draws a line between two points to plotsscreen. This is a no-clipping routine, which means that both coordinates should be on the screen. <i>posa</i> and <i>posb</i> are double bytes with the first byte (MSB) being the x-coord and the second byte (LSB) being the y-coord.
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  ionGetPixel
;
; Written by:
;  Badja
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   draw.line(posa,posb) load(hl,posa)
   #DEFCONT  \ load(de,posb)
   #DEFCONT  \ call api_draw_line
   #DEFCONT  \ #DEFINE api_use_draw_line

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_draw_line

api_draw_line:

   ; hl = posa
   ; de = posb

lineDraw:
      ld    a,h
      sub   d
      jr    nc,ld_noAbsX
      neg
ld_noAbsX:
      ld    b,a               ; B = |dx|
      ld    a,l
      sub   e
      ld    c,a               ; C = dy
      jr    nc,ld_noAbsY
      neg
ld_noAbsY:                    ; A = |dy|
      cp    b
      jr    nc,ld_rotated

      ld    a,h
      sub   d                 ; A = dx
      bit   7,a
      jr    z,ld_noSwap1
      ex    de,hl
      ld    a,b               ; A = |dx|
ld_noSwap1:
      push  af
      push  de
      neg
      ld    d,a               ; D = -dx
      ld    bc,12
      ld    a,e
      cp    l
      jr    c,ld_noReflectX
      ld    e,l
      ld    l,a
      ld    bc,-12
ld_noReflectX:
      ld    (ld_setIncrY),bc
      ld    b,$ff
      ld    c,d               ; BC = -dx
      ld    h,0               ; HL = y1
      ld    d,h               ; DE = y0
      and   a                 ; set C flag to zero
      sbc   hl,de             ; HL = dy
      add   hl,hl
      ld    (ld_setIncrE),hl
      add   hl,bc
      ld    d,h
      ld    e,l               ; DE = d
      add   hl,bc
      ld    (ld_setIncrESE),hl
      pop   bc                ; B = x0, C = y0
      push  de
      ld    a,b
      ld    e,c
      call  ionGetPixel       ; HL -> graphbuffer offset, A = pixel mask
      push  hl
      pop   ix                ; IX -> graphbuffer offset
      pop   hl                ; HL = d
      pop   bc                ; B = |dx|
      ld    d,a
      or    (ix)
      ld    (ix),a
      ld    a,b
      or    a
      ret   z
ld_lineLoopE:
      ld    a,d
      bit   7,h
      jr    z,ld_goESE
ld_setIncrE = $ + 1
      ld    de,$0000
      add   hl,de
      jr    ld_incrementX
ld_goESE:
ld_setIncrESE = $ + 1
      ld    de,$0000
      add   hl,de
ld_setIncrY = $ + 1
      ld    de,$0000
      add   ix,de
ld_incrementX:
      rrca
      jr    nc,ld_sameByte1
      inc   ix
ld_sameByte1:
      ld    d,a
      or    (ix)
      ld    (ix),a
      djnz  ld_lineLoopE
      ret

ld_rotated:
      bit   7,c               ; C = dy
      jr    z,ld_noSwap2
      ex    de,hl
      ld    c,a               ; C = |dy|
ld_noSwap2:
      ld    a,c
      push  af
      push  de
      neg
      ld    c,a               ; C = -dy
      ld    l,h
      ld    e,d
      ld    a,e
      cp    l
      ld    a,$0f             ; opcode for RRCA
      ld    b,$23             ; second byte of opcode for INC IX
      jr    c,ld_noReflectY
      ld    e,l
      ld    l,d
      ld    a,$07             ; opcode for RLCA
      ld    b,$2b             ; second byte of opcode for DEC IX
ld_noReflectY:
      ld    (ld_setIncrX1),a
      ld    a,b
      ld    (ld_setIncrX2),a
      ld    b,$ff             ; BC = -dy
      ld    h,0               ; HL = x1
      ld    d,h               ; DE = x0
      and   a                 ; set C flag to zero
      sbc   hl,de             ; HL = dx
      add   hl,hl
      ld    (ld_setIncrS),hl
      add   hl,bc
      ld    d,h
      ld    e,l               ; DE = d
      add   hl,bc
      ld    (ld_setIncrSSE),hl
      pop   bc                ; B = x0, C = y0
      push  de
      ld    a,b
      ld    e,c
      call  ionGetPixel       ; HL -> graphbuffer offset, A = pixel mask
      push  hl
      pop   ix                ; IX -> graphbuffer offset
      pop   hl                ; HL = d
      pop   bc                ; B = |dy|
      ld    d,a
      or    (ix)
      ld    (ix),a
      ld    a,b
      or    a
      ret   z
ld_lineLoopS:
      ld    a,d
      bit   7,h
      jr    z,ld_goSSE
ld_setIncrS = $ + 1
      ld    de,$0000
      add   hl,de
      jr    ld_incrementY
ld_goSSE:
ld_setIncrSSE = $ + 1
      ld    de,$0000
      add   hl,de
ld_setIncrX1 = $
      rrca
      jr    nc,ld_sameByte2
ld_setIncrX2 = $ + 1
      inc   ix
ld_sameByte2:
ld_incrementY:
      ld    de,12
      add   ix,de
      ld    d,a
      or    (ix)
      ld    (ix),a
      djnz  ld_lineLoopS
      ret

#ENDIF
#ENDIF

; ***
; [routine]draw.square(%ul,%lr,#color)[/routine]
;
; Draws a square from (h,l) to (d,e)
; Color can be any value, but only $FF and $00 will look like they should.
;
; This routine isn't stable yet
;
; Example:
;  draw.square(256*10+10,256*20+20)
;  ; draws a 10x10 square at (10,10)
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Depends on:
;  draw.horizLine
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   draw.square(ul,lr,color) load(hl,ul)
   #DEFCONT  \ load(de,lr)
   #DEFCONT  \ load(a,color)
   #DEFCONT  \ call api_draw_square
   #DEFCONT  \ #DEFINE api_use_draw_square

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_draw_square

   #DEFINE api_use_draw_horizLine

api_draw_square:

   ; hl = ul
   ; de = lr
   ; draw block from (h,l) to (d,e)
   ; a:  0   = white
   ;     $FF = black

	ld (api_drawline_color),a	; store color
	ld a,h				; ~~\
	cp 96
	jr c,api_drawblock_skip1
	ld h,96
api_drawblock_skip1:
	ld a,d
	cp 96
	jr c,api_drawblock_skip2
	ld d,96			;       -- Check for off screen coords
api_drawblock_skip2:
	ld a,l
	cp 64
	jr c,api_drawblock_skip3
	ld l,64
api_drawblock_skip3:
	ld a,e
	cp 64
	jr c,api_drawblock_loop
	ld e,64			; __/
api_drawblock_loop:
	ld a,l
	cp e
	ret nc				; check if coord1 is still higher than coord2
	push hl
	push de
	ld e,l				; if so; draw uppermost line
	call api_drawline_dontset
	pop de
	pop hl
	inc l				; and go down one pixel
	jp api_drawblock_loop

#ENDIF
#ENDIF

; ***
; [routine]draw.horizLine(%ul,%lr,#color)[/routine]
;
; draw horizontal line from (h,l) to (d,e), obviously requires l = e
; Color can be any value, but only $FF and $00 will look like they should.
;
; This routine isn't stable yet
;
; Example:
;  Write example
;
; Size:
;  ?? bytes routine + ?? bytes invocation
;
; Written by:
;  Timendus
;

#IFDEF api_defines
#IFNDEF api_routines

   #DEFINE   draw.horizLine(ul,lr,color) load(hl,ul)
   #DEFCONT  \ load(de,lr)
   #DEFCONT  \ load(a,color)
   #DEFCONT  \ call api_draw_horizLine
   #DEFCONT  \ #DEFINE api_use_draw_horizLine

#ENDIF
#ENDIF

#IFDEF api_routines
#IFDEF api_use_draw_horizLine

api_draw_horizLine:

   ; hl = ul
   ; de = lr
   ; a:  0   = white
   ;     $FF = black

	ld (api_drawline_color),a	; store color
api_drawline_dontset:
	push hl
	ld a,h
	call api_drawline_getmask			; get left mask
	ld b,a
	ld a,d
	call api_drawline_getmask			; get right mask
	cpl
	ld c,a
	pop hl
	push bc			; store masks
	call api_drawline_getbyte			; get left bytepointer
	push hl
	ld h,d
	ld l,e
	call api_drawline_getbyte			; get right bytepointer
	pop de
	push de
	push hl
	sbc hl,de			; calculate distance between bytepointers
	jp z,api_drawline_onebyte	; if same byte, skip to onebyte
	ld a,l
	cp 1
	jp z,api_drawline_skip_inner	; if two succeeding bytes, skip filling inner bytes
	ld b,l
	dec b
	ex de,hl
	inc hl
	ld a,(api_drawline_color)
api_drawline_loop_inner:
	ld (hl),a			; Fill inner bytes up with color
	inc hl
	djnz api_drawline_loop_inner
api_drawline_skip_inner:
	pop de				; get right bytepointer
	pop hl				; get left bytepointer
	pop bc				; get masks
	call api_drawline_modify
	ex de,hl
	ld b,c
	jp api_drawline_modify
api_drawline_onebyte:
	pop de				; get right bytepointer
	pop hl				; get left bytepointer
	pop bc				; get masks
	ld a,b
	and c				; merge masks
	ld b,a
api_drawline_modify:			; make the changes to the address in hl
	ld a,(api_drawline_color)
	or a
	jp z,api_drawline_white
	ld a,(hl)
	or b				; OR with screen
	ld (hl),a
	ret
api_drawline_white:
	ld a,(hl)
	cpl				; invert screen
	or b				; OR with inverted screen
	cpl				; invert back
	ld (hl),a
	ret
api_drawline_getbyte:
	ld a,h				; calculate pointer to byte in plotsscreen
	ld h,0				; h = x, l = y
	ld b,h
	ld c,l
	add hl,hl			; l times 12
	add hl,bc
	add hl,hl
	add hl,hl
	ld c,a
	srl c				; x devided by 8
	srl c
	srl c
	add hl,bc
	ld bc,plotsscreen
	add hl,bc
	ret
api_drawline_getmask:
	and 7				; look mask up in table
	ld hl,api_drawline_lut
	add a,l
	ld l,a
	ld a,(hl)
	ret
api_drawline_lut:
	.db %11111111
	.db %01111111
	.db %00111111
	.db %00011111
	.db %00001111
	.db %00000111
	.db %00000011
	.db %00000001
api_drawline_color:
	.db $FF

#ENDIF
#ENDIF

